/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a<<8) | b)

static int make_pair(int i1, int i2)
{
  unsigned u1 = i1;
  unsigned u2 = i2;

  if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
    cf_error( "Can't operate with value out of bounds in pair constructor");

  return (u1 << 16) | u2;
}

struct f_tree *f_generate_rev_wcard(int from, int to, int expr)
{
	struct f_tree *ret = NULL, *last = NULL;

	while (from <= to) {
		ret = f_new_tree(); 
		ret->from.type = ret->to.type = T_PAIR;
		ret->from.val.i = ret->to.val.i = make_pair(from, expr); 
		ret->left = last;

		from++; last = ret;
	}
	return ret;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->stub != 0))
    cf_error( "Backbone area cannot be stub");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "No configured areas in OSPF");
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix

static struct radv_prefix_config *this_radv_prefix;

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;



/* Line 189 of yacc.c  */
#line 314 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     GEQ = 262,
     LEQ = 263,
     NEQ = 264,
     AND = 265,
     OR = 266,
     PO = 267,
     PC = 268,
     NUM = 269,
     ENUM = 270,
     RTRID = 271,
     IPA = 272,
     SYM = 273,
     TEXT = 274,
     PREFIX_DUMMY = 275,
     DEFINE = 276,
     ON = 277,
     OFF = 278,
     YES = 279,
     NO = 280,
     LOG = 281,
     SYSLOG = 282,
     ALL = 283,
     DEBUG = 284,
     TRACE = 285,
     INFO = 286,
     REMOTE = 287,
     WARNING = 288,
     ERROR = 289,
     AUTH = 290,
     FATAL = 291,
     BUG = 292,
     STDERR = 293,
     SOFT = 294,
     TIMEFORMAT = 295,
     ISO = 296,
     SHORT = 297,
     LONG = 298,
     BASE = 299,
     NAME = 300,
     CONFIGURE = 301,
     DOWN = 302,
     KERNEL = 303,
     PERSIST = 304,
     SCAN = 305,
     TIME = 306,
     LEARN = 307,
     DEVICE = 308,
     ROUTES = 309,
     ASYNC = 310,
     TABLE = 311,
     ROUTER = 312,
     ID = 313,
     PROTOCOL = 314,
     PREFERENCE = 315,
     DISABLED = 316,
     DIRECT = 317,
     INTERFACE = 318,
     IMPORT = 319,
     EXPORT = 320,
     FILTER = 321,
     NONE = 322,
     STATES = 323,
     FILTERS = 324,
     PASSWORD = 325,
     FROM = 326,
     PASSIVE = 327,
     TO = 328,
     EVENTS = 329,
     PACKETS = 330,
     PROTOCOLS = 331,
     INTERFACES = 332,
     PRIMARY = 333,
     STATS = 334,
     COUNT = 335,
     FOR = 336,
     COMMANDS = 337,
     PREEXPORT = 338,
     GENERATE = 339,
     LISTEN = 340,
     BGP = 341,
     V6ONLY = 342,
     DUAL = 343,
     ADDRESS = 344,
     PORT = 345,
     PASSWORDS = 346,
     DESCRIPTION = 347,
     RELOAD = 348,
     IN = 349,
     OUT = 350,
     MRTDUMP = 351,
     MESSAGES = 352,
     RESTRICT = 353,
     MEMORY = 354,
     IGP_METRIC = 355,
     SHOW = 356,
     STATUS = 357,
     SUMMARY = 358,
     ROUTE = 359,
     SYMBOLS = 360,
     DUMP = 361,
     RESOURCES = 362,
     SOCKETS = 363,
     NEIGHBORS = 364,
     ATTRIBUTES = 365,
     ECHO = 366,
     DISABLE = 367,
     ENABLE = 368,
     RESTART = 369,
     FUNCTION = 370,
     PRINT = 371,
     PRINTN = 372,
     UNSET = 373,
     RETURN = 374,
     ACCEPT = 375,
     REJECT = 376,
     QUITBIRD = 377,
     INT = 378,
     BOOL = 379,
     IP = 380,
     PREFIX = 381,
     PAIR = 382,
     QUAD = 383,
     SET = 384,
     STRING = 385,
     BGPMASK = 386,
     BGPPATH = 387,
     CLIST = 388,
     IF = 389,
     THEN = 390,
     ELSE = 391,
     CASE = 392,
     TRUE = 393,
     FALSE = 394,
     GW = 395,
     NET = 396,
     MASK = 397,
     PROTO = 398,
     SOURCE = 399,
     SCOPE = 400,
     CAST = 401,
     DEST = 402,
     LEN = 403,
     DEFINED = 404,
     ADD = 405,
     DELETE = 406,
     CONTAINS = 407,
     RESET = 408,
     PREPEND = 409,
     FIRST = 410,
     LAST = 411,
     MATCH = 412,
     EMPTY = 413,
     WHERE = 414,
     EVAL = 415,
     LOCAL = 416,
     NEIGHBOR = 417,
     AS = 418,
     HOLD = 419,
     CONNECT = 420,
     RETRY = 421,
     KEEPALIVE = 422,
     MULTIHOP = 423,
     STARTUP = 424,
     VIA = 425,
     NEXT = 426,
     HOP = 427,
     SELF = 428,
     DEFAULT = 429,
     PATH = 430,
     METRIC = 431,
     START = 432,
     DELAY = 433,
     FORGET = 434,
     WAIT = 435,
     AFTER = 436,
     BGP_PATH = 437,
     BGP_LOCAL_PREF = 438,
     BGP_MED = 439,
     BGP_ORIGIN = 440,
     BGP_NEXT_HOP = 441,
     BGP_ATOMIC_AGGR = 442,
     BGP_AGGREGATOR = 443,
     BGP_COMMUNITY = 444,
     RR = 445,
     RS = 446,
     CLIENT = 447,
     CLUSTER = 448,
     AS4 = 449,
     ADVERTISE = 450,
     IPV4 = 451,
     CAPABILITIES = 452,
     LIMIT = 453,
     PREFER = 454,
     OLDER = 455,
     MISSING = 456,
     LLADDR = 457,
     DROP = 458,
     IGNORE = 459,
     REFRESH = 460,
     INTERPRET = 461,
     COMMUNITIES = 462,
     BGP_ORIGINATOR_ID = 463,
     BGP_CLUSTER_LIST = 464,
     IGP = 465,
     GATEWAY = 466,
     RECURSIVE = 467,
     OSPF = 468,
     AREA = 469,
     OSPF_METRIC1 = 470,
     OSPF_METRIC2 = 471,
     OSPF_TAG = 472,
     OSPF_ROUTER_ID = 473,
     RFC1583COMPAT = 474,
     STUB = 475,
     TICK = 476,
     COST = 477,
     RETRANSMIT = 478,
     HELLO = 479,
     TRANSMIT = 480,
     PRIORITY = 481,
     DEAD = 482,
     TYPE = 483,
     BROADCAST = 484,
     BCAST = 485,
     NONBROADCAST = 486,
     NBMA = 487,
     POINTOPOINT = 488,
     PTP = 489,
     POINTOMULTIPOINT = 490,
     PTMP = 491,
     SIMPLE = 492,
     AUTHENTICATION = 493,
     STRICT = 494,
     CRYPTOGRAPHIC = 495,
     ELIGIBLE = 496,
     POLL = 497,
     NETWORKS = 498,
     HIDDEN = 499,
     VIRTUAL = 500,
     CHECK = 501,
     LINK = 502,
     RX = 503,
     BUFFER = 504,
     LARGE = 505,
     NORMAL = 506,
     STUBNET = 507,
     LSADB = 508,
     ECMP = 509,
     WEIGHT = 510,
     TOPOLOGY = 511,
     STATE = 512,
     PIPE = 513,
     PEER = 514,
     MODE = 515,
     OPAQUE = 516,
     TRANSPARENT = 517,
     RADV = 518,
     MIN = 519,
     MAX = 520,
     RA = 521,
     INTERVAL = 522,
     MANAGED = 523,
     OTHER = 524,
     CONFIG = 525,
     MTU = 526,
     REACHABLE = 527,
     RETRANS = 528,
     TIMER = 529,
     CURRENT = 530,
     VALID = 531,
     PREFERRED = 532,
     LIFETIME = 533,
     SKIP = 534,
     ONLINK = 535,
     AUTONOMOUS = 536,
     RIP = 537,
     INFINITY = 538,
     PERIOD = 539,
     GARBAGE = 540,
     TIMEOUT = 541,
     MULTICAST = 542,
     QUIET = 543,
     NOLISTEN = 544,
     VERSION1 = 545,
     PLAINTEXT = 546,
     MD5 = 547,
     HONOR = 548,
     NEVER = 549,
     ALWAYS = 550,
     RIP_METRIC = 551,
     RIP_TAG = 552,
     STATIC = 553,
     PROHIBIT = 554,
     MULTIPATH = 555
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 236 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 214 of yacc.c  */
#line 674 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 686 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  54
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1992

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  322
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  216
/* YYNRULES -- Number of rules.  */
#define YYNRULES  671
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1268

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   555

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    30,     2,     2,     2,    29,     2,     2,
     312,   313,    27,    25,   318,    26,    31,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   315,   314,
      22,    21,    23,   319,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   320,     2,   321,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   316,     2,   317,    24,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    74,
      75,    77,    80,    82,    84,    88,    90,    94,    96,    98,
     100,   102,   104,   106,   108,   110,   112,   117,   121,   123,
     125,   127,   129,   132,   137,   141,   145,   149,   153,   158,
     161,   162,   164,   167,   170,   174,   177,   181,   184,   188,
     192,   196,   201,   203,   205,   207,   212,   213,   216,   219,
     222,   224,   226,   229,   231,   232,   234,   235,   238,   241,
     244,   247,   250,   253,   256,   260,   263,   266,   268,   270,
     272,   274,   278,   282,   283,   285,   287,   290,   291,   293,
     297,   299,   303,   306,   310,   314,   318,   319,   323,   325,
     327,   331,   333,   337,   339,   341,   343,   345,   347,   349,
     351,   353,   357,   359,   363,   365,   367,   372,   374,   375,
     379,   384,   386,   389,   390,   396,   402,   408,   414,   419,
     423,   427,   432,   438,   440,   441,   445,   450,   455,   456,
     459,   463,   467,   471,   474,   477,   480,   484,   488,   491,
     494,   496,   498,   503,   507,   511,   515,   519,   523,   527,
     531,   536,   538,   540,   542,   543,   545,   549,   553,   557,
     561,   566,   571,   576,   581,   584,   586,   588,   590,   592,
     593,   595,   596,   601,   604,   606,   608,   610,   612,   614,
     616,   618,   620,   622,   624,   627,   630,   631,   635,   637,
     641,   643,   645,   647,   650,   654,   657,   662,   663,   669,
     670,   672,   674,   677,   679,   683,   685,   687,   689,   691,
     693,   699,   708,   721,   727,   733,   739,   741,   746,   748,
     752,   756,   758,   761,   764,   771,   773,   777,   778,   783,
     787,   789,   793,   797,   801,   804,   807,   810,   813,   814,
     817,   820,   821,   827,   829,   831,   833,   835,   837,   839,
     841,   845,   849,   851,   853,   854,   859,   861,   863,   865,
     867,   869,   871,   873,   875,   877,   881,   885,   889,   893,
     897,   901,   905,   909,   913,   917,   921,   925,   929,   933,
     936,   941,   943,   945,   947,   949,   952,   955,   959,   963,
     970,   974,   978,   982,   986,   993,  1000,  1007,  1012,  1014,
    1016,  1018,  1020,  1022,  1024,  1026,  1027,  1029,  1033,  1035,
    1039,  1040,  1042,  1047,  1054,  1059,  1063,  1069,  1075,  1080,
    1087,  1091,  1094,  1100,  1106,  1115,  1124,  1133,  1136,  1140,
    1144,  1150,  1157,  1164,  1171,  1176,  1181,  1187,  1194,  1201,
    1207,  1211,  1216,  1222,  1228,  1234,  1240,  1245,  1250,  1256,
    1262,  1268,  1274,  1280,  1286,  1293,  1300,  1309,  1316,  1323,
    1329,  1334,  1340,  1345,  1351,  1356,  1362,  1368,  1371,  1375,
    1379,  1381,  1384,  1387,  1392,  1395,  1397,  1400,  1405,  1406,
    1410,  1414,  1417,  1422,  1425,  1428,  1430,  1435,  1437,  1439,
    1440,  1444,  1447,  1450,  1453,  1458,  1460,  1461,  1465,  1466,
    1469,  1472,  1476,  1479,  1482,  1486,  1489,  1492,  1495,  1497,
    1501,  1504,  1507,  1510,  1513,  1516,  1519,  1523,  1526,  1529,
    1532,  1535,  1538,  1541,  1544,  1547,  1551,  1554,  1558,  1561,
    1565,  1569,  1574,  1577,  1580,  1583,  1587,  1591,  1595,  1597,
    1598,  1601,  1603,  1605,  1608,  1612,  1613,  1616,  1618,  1620,
    1623,  1627,  1628,  1629,  1633,  1634,  1638,  1642,  1644,  1645,
    1650,  1657,  1664,  1671,  1679,  1686,  1694,  1701,  1704,  1708,
    1712,  1718,  1723,  1728,  1731,  1733,  1736,  1739,  1740,  1744,
    1749,  1750,  1755,  1760,  1764,  1767,  1771,  1775,  1779,  1783,
    1788,  1792,  1795,  1796,  1797,  1801,  1802,  1806,  1811,  1813,
    1816,  1819,  1822,  1826,  1830,  1831,  1832,  1836,  1837,  1841,
    1845,  1848,  1852,  1856,  1861,  1866,  1871,  1877,  1883,  1888,
    1892,  1897,  1902,  1907,  1912,  1914,  1916,  1918,  1920,  1922,
    1924,  1926,  1928,  1929,  1932,  1935,  1936,  1940,  1941,  1945,
    1946,  1950,  1953,  1957,  1961,  1967,  1971,  1974,  1977,  1981,
    1983,  1986,  1990,  1994,  1998,  2001,  2004,  2007,  2012,  2014,
    2016,  2018,  2020,  2022,  2024,  2026,  2028,  2030,  2032,  2034,
    2036,  2038,  2040,  2042,  2044,  2046,  2048,  2050,  2052,  2054,
    2056,  2058,  2060,  2062,  2064,  2066,  2068,  2070,  2072,  2074,
    2076,  2078,  2080,  2082,  2084,  2086,  2088,  2090,  2092,  2094,
    2096,  2098,  2100,  2102,  2104,  2106,  2108,  2110,  2112,  2115,
    2118,  2121,  2124,  2127,  2130,  2133,  2136,  2139,  2143,  2147,
    2151,  2155,  2159,  2163,  2167,  2169,  2171,  2173,  2175,  2177,
    2179,  2181,  2183,  2185,  2187,  2189,  2191,  2193,  2195,  2197,
    2199,  2201
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     323,     0,    -1,   324,     3,    -1,     4,   533,    -1,    -1,
     324,   532,    -1,    14,    -1,   312,   452,   313,    -1,    18,
      -1,    32,    18,    21,   325,   314,    -1,    32,    18,    21,
      17,   314,    -1,   325,    -1,    33,    -1,    35,    -1,    34,
      -1,    36,    -1,    -1,    17,    -1,    18,    -1,   328,   331,
      -1,   329,    -1,   328,    -1,    28,   325,    -1,   315,   328,
      -1,    19,    -1,    19,    -1,    -1,    37,   336,   337,   314,
      -1,    56,    19,    -1,    -1,    19,    -1,    38,   335,    -1,
      49,    -1,    39,    -1,   316,   338,   317,    -1,   339,    -1,
     338,   318,   339,    -1,    40,    -1,    41,    -1,    42,    -1,
      43,    -1,    44,    -1,    45,    -1,    46,    -1,    47,    -1,
      48,    -1,   107,    87,   377,   314,    -1,   107,    19,   314,
      -1,   115,    -1,    70,    -1,    55,    -1,    37,    -1,   341,
      19,    -1,   341,    19,   325,    19,    -1,   341,    52,    53,
      -1,   341,    52,    54,    -1,    51,   342,   314,    -1,    57,
     347,     3,    -1,    57,    50,   347,     3,    -1,    58,     3,
      -1,    -1,    19,    -1,   359,    59,    -1,    60,   327,    -1,
      61,    62,   325,    -1,    63,   327,    -1,    64,    65,   327,
      -1,   359,    64,    -1,    61,    62,   325,    -1,    89,   333,
     330,    -1,    59,    67,   325,    -1,    68,    69,   354,   314,
      -1,    14,    -1,    16,    -1,    17,    -1,    96,    97,   356,
     314,    -1,    -1,   356,   357,    -1,   100,   328,    -1,   101,
     325,    -1,    98,    -1,    99,    -1,    67,    18,    -1,    70,
      -1,    -1,    18,    -1,    -1,    71,   325,    -1,    72,   327,
      -1,    40,   374,    -1,   107,   377,    -1,    75,   362,    -1,
      76,   362,    -1,    67,   363,    -1,    68,    69,   354,    -1,
     103,    19,    -1,    77,   425,    -1,   426,    -1,    39,    -1,
      78,    -1,    18,    -1,    40,    87,   374,    -1,    40,    93,
     325,    -1,    -1,    19,    -1,   330,    -1,    19,   330,    -1,
      -1,    26,    -1,   365,   367,   366,    -1,   368,    -1,   369,
     318,   368,    -1,   359,    73,    -1,   370,   360,   316,    -1,
     371,   361,   314,    -1,   371,   373,   314,    -1,    -1,    74,
     372,   369,    -1,    39,    -1,    34,    -1,   316,   375,   317,
      -1,   376,    -1,   375,   318,   376,    -1,    79,    -1,    65,
      -1,    80,    -1,    88,    -1,    85,    -1,    86,    -1,    39,
      -1,    34,    -1,   316,   378,   317,    -1,   379,    -1,   378,
     318,   379,    -1,    79,    -1,   108,    -1,   102,   316,   381,
     317,    -1,   382,    -1,    -1,   382,   314,   381,    -1,   383,
     316,   384,   317,    -1,   383,    -1,    81,    19,    -1,    -1,
      95,    82,   332,   314,   384,    -1,    95,    84,   332,   314,
     384,    -1,   131,    82,   332,   314,   384,    -1,   131,    84,
     332,   314,   384,    -1,    69,   325,   314,   384,    -1,   112,
     113,     3,    -1,   112,   110,     3,    -1,   112,    87,   416,
       3,    -1,   112,    87,    39,   416,     3,    -1,    18,    -1,
      -1,   112,    88,     3,    -1,   112,    88,   114,     3,    -1,
     112,   115,   393,     3,    -1,    -1,   393,   329,    -1,   393,
      92,   330,    -1,   393,    67,    18,    -1,   393,    77,   425,
      -1,   393,   426,    -1,   393,    39,    -1,   393,    89,    -1,
     393,   394,    18,    -1,   393,    70,    18,    -1,   393,    90,
      -1,   393,    91,    -1,    94,    -1,    76,    -1,   112,   116,
     389,     3,    -1,   117,   118,     3,    -1,   117,   119,     3,
      -1,   117,    88,     3,    -1,   117,   120,     3,    -1,   117,
     121,     3,    -1,   117,    65,     3,    -1,   117,    87,     3,
      -1,   122,   404,   405,     3,    -1,    39,    -1,    34,    -1,
      14,    -1,    -1,    14,    -1,   123,   415,     3,    -1,   124,
     415,     3,    -1,   125,   415,     3,    -1,   104,   415,     3,
      -1,   104,   105,   415,     3,    -1,   104,   106,   415,     3,
      -1,    40,   415,   374,     3,    -1,   107,   415,   377,     3,
      -1,   109,     3,    -1,    18,    -1,    39,    -1,    19,    -1,
      18,    -1,    -1,    19,    -1,    -1,    77,    18,   418,   424,
      -1,   171,   452,    -1,   134,    -1,   135,    -1,   136,    -1,
     137,    -1,   138,    -1,   139,    -1,   141,    -1,   142,    -1,
     143,    -1,   144,    -1,   420,   140,    -1,   420,    18,    -1,
      -1,   421,   314,   422,    -1,   421,    -1,   423,   314,   421,
      -1,   428,    -1,    18,    -1,   424,    -1,   170,   452,    -1,
     312,   423,   313,    -1,   312,   313,    -1,   422,   316,   431,
     317,    -1,    -1,   126,    18,   430,   427,   428,    -1,    -1,
     432,    -1,   458,    -1,   432,   458,    -1,   458,    -1,   316,
     431,   317,    -1,    17,    -1,   325,    -1,    16,    -1,   434,
      -1,    15,    -1,   312,   325,   318,   325,   313,    -1,   312,
     325,   318,   325,    31,    31,   325,   313,    -1,   312,   325,
     318,   325,   313,    31,    31,   312,   325,   318,   325,   313,
      -1,   312,    27,   318,    27,   313,    -1,   312,   325,   318,
      27,   313,    -1,   312,    27,   318,   325,   313,    -1,   435,
      -1,   435,    31,    31,   435,    -1,   436,    -1,   437,   318,
     436,    -1,    17,    28,    14,    -1,   438,    -1,   438,    25,
      -1,   438,    26,    -1,   438,   316,    14,   318,    14,   317,
      -1,   439,    -1,   440,   318,   439,    -1,    -1,   441,   436,
     315,   431,    -1,   441,     6,   431,    -1,   450,    -1,   312,
     452,   313,    -1,    12,   444,    13,    -1,    28,   445,    28,
      -1,    14,   444,    -1,    27,   444,    -1,   319,   444,    -1,
     442,   444,    -1,    -1,    14,   445,    -1,   319,   445,    -1,
      -1,   312,   452,   318,   452,   313,    -1,    14,    -1,   149,
      -1,   150,    -1,    19,    -1,   434,    -1,   438,    -1,    16,
      -1,   320,   437,   321,    -1,   320,   440,   321,    -1,    15,
      -1,   443,    -1,    -1,    18,   312,   457,   313,    -1,    18,
      -1,    82,    -1,   151,    -1,   152,    -1,   154,    -1,   155,
      -1,   156,    -1,   157,    -1,   158,    -1,   312,   452,   313,
      -1,   452,    25,   452,    -1,   452,    26,   452,    -1,   452,
      27,   452,    -1,   452,    28,   452,    -1,   452,    10,   452,
      -1,   452,    11,   452,    -1,   452,    21,   452,    -1,   452,
       9,   452,    -1,   452,    22,   452,    -1,   452,     8,   452,
      -1,   452,    23,   452,    -1,   452,     7,   452,    -1,   452,
      24,   452,    -1,    30,   452,    -1,   160,   312,   452,   313,
      -1,   450,    -1,   447,    -1,   446,    -1,    71,    -1,   448,
     451,    -1,   448,   537,    -1,   452,    31,   136,    -1,   452,
      31,   159,    -1,   452,    31,   153,   312,   452,   313,    -1,
     452,    31,   166,    -1,   452,    31,   167,    -1,    25,   169,
      25,    -1,    26,   169,    26,    -1,   165,   312,   452,   318,
     452,   313,    -1,   161,   312,   452,   318,   452,   313,    -1,
     162,   312,   452,   318,   452,   313,    -1,    18,   312,   457,
     313,    -1,   133,    -1,   131,    -1,   132,    -1,    45,    -1,
     127,    -1,   128,    -1,   452,    -1,    -1,   454,    -1,   454,
     318,   455,    -1,   452,    -1,   452,   318,   456,    -1,    -1,
     456,    -1,   145,   452,   146,   433,    -1,   145,   452,   146,
     433,   147,   433,    -1,    18,    21,   452,   314,    -1,   130,
     452,   314,    -1,   448,   537,    21,   452,   314,    -1,   448,
     451,    21,   452,   314,    -1,    71,    21,   452,   314,    -1,
     129,   312,   448,   537,   313,   314,    -1,   453,   455,   314,
      -1,   449,   314,    -1,   148,   452,   316,   441,   317,    -1,
     448,   537,    31,   169,   314,    -1,   448,   537,    31,   165,
     312,   452,   313,   314,    -1,   448,   537,    31,   161,   312,
     452,   313,   314,    -1,   448,   537,    31,   162,   312,   452,
     313,   314,    -1,   359,    97,    -1,   459,   360,   316,    -1,
     460,   361,   314,    -1,   460,   172,   174,   325,   314,    -1,
     460,   172,   328,   174,   325,   314,    -1,   460,   173,   328,
     174,   325,   314,    -1,   460,   201,   204,    69,   354,   314,
      -1,   460,   201,   203,   314,    -1,   460,   202,   203,   314,
      -1,   460,   175,    62,   325,   314,    -1,   460,   180,   175,
      62,   325,   314,    -1,   460,   176,   177,    62,   325,   314,
      -1,   460,   178,    62,   325,   314,    -1,   460,   179,   314,
      -1,   460,   179,   325,   314,    -1,   460,   182,   183,   184,
     314,    -1,   460,   212,   213,   184,   314,    -1,   460,   212,
     213,   214,   314,    -1,   460,   212,   213,   215,   314,    -1,
     460,   222,    73,   314,    -1,   460,   222,   223,   314,    -1,
     460,   186,   187,   327,   314,    -1,   460,   221,   187,   327,
     314,    -1,   460,   210,   211,   327,   314,    -1,   460,   185,
     195,   325,   314,    -1,   460,   185,   194,   325,   314,    -1,
     460,   155,   100,   328,   314,    -1,   460,   188,   189,    62,
     325,   314,    -1,   460,    45,   190,    62,   325,   314,    -1,
     460,    45,   191,    62,   325,   318,   325,   314,    -1,   460,
     123,   192,    45,   327,   314,    -1,   460,   124,   115,   216,
     327,   314,    -1,   460,   124,   205,   327,   314,    -1,   460,
     208,   327,   314,    -1,   460,   206,   207,   327,   314,    -1,
     460,    81,    19,   314,    -1,   460,   115,   209,   325,   314,
      -1,   460,    83,   327,   314,    -1,   460,   217,   218,   327,
     314,    -1,   460,   221,    67,   363,   314,    -1,   359,   224,
      -1,   461,   360,   316,    -1,   462,   463,   314,    -1,   361,
      -1,   230,   327,    -1,   265,   327,    -1,   265,   327,   209,
     325,    -1,   232,   325,    -1,   465,    -1,   225,   354,    -1,
     464,   316,   466,   317,    -1,    -1,   466,   467,   314,    -1,
     231,   233,   325,    -1,   231,   327,    -1,   254,   316,   477,
     317,    -1,   263,   468,    -1,    74,   488,    -1,   472,    -1,
     469,   316,   470,   317,    -1,   469,    -1,   329,    -1,    -1,
     470,   471,   314,    -1,   255,   327,    -1,   114,   327,    -1,
     233,   325,    -1,   475,   316,   473,   317,    -1,   475,    -1,
      -1,   473,   474,   314,    -1,    -1,   235,   325,    -1,   234,
     325,    -1,   236,   189,   325,    -1,   191,   325,    -1,   238,
     325,    -1,   238,    91,   325,    -1,   249,    78,    -1,   249,
     248,    -1,   249,   251,    -1,   380,    -1,   256,   258,   354,
      -1,   233,   325,    -1,   235,   325,    -1,   253,   325,    -1,
     234,   325,    -1,   191,   325,    -1,   238,   325,    -1,   238,
      91,   325,    -1,   239,   240,    -1,   239,   241,    -1,   239,
     242,    -1,   239,   243,    -1,   239,   244,    -1,   239,   245,
      -1,   239,   246,    -1,   239,   247,    -1,   236,   189,   325,
      -1,   237,   325,    -1,   250,   242,   327,    -1,   231,   327,
      -1,   257,   258,   327,    -1,   265,   266,   325,    -1,   120,
     316,   481,   317,    -1,   249,    78,    -1,   249,   248,    -1,
     249,   251,    -1,   259,   260,   261,    -1,   259,   260,   262,
      -1,   259,   260,   325,    -1,   380,    -1,    -1,   477,   478,
      -1,   479,    -1,   480,    -1,   329,   314,    -1,   329,   255,
     314,    -1,    -1,   481,   482,    -1,   483,    -1,   484,    -1,
      17,   314,    -1,    17,   252,   314,    -1,    -1,    -1,   486,
     476,   314,    -1,    -1,   316,   486,   317,    -1,   485,   369,
     487,    -1,    19,    -1,    -1,   112,   224,   389,     3,    -1,
     112,   224,   120,   389,   489,     3,    -1,   112,   224,    74,
     389,   489,     3,    -1,   112,   224,   267,   389,   489,     3,
      -1,   112,   224,   267,    39,   389,   489,     3,    -1,   112,
     224,   268,   389,   489,     3,    -1,   112,   224,   268,    39,
     389,   489,     3,    -1,   112,   224,   264,   389,   489,     3,
      -1,   359,   269,    -1,   498,   360,   316,    -1,   499,   361,
     314,    -1,   499,   270,    67,    18,   314,    -1,   499,   271,
     272,   314,    -1,   499,   271,   273,   314,    -1,   359,   274,
      -1,   361,    -1,   137,   515,    -1,    74,   509,    -1,    -1,
     502,   501,   314,    -1,   500,   360,   316,   502,    -1,    -1,
     275,   277,   278,   325,    -1,   276,   277,   278,   325,    -1,
     275,   189,   325,    -1,   279,   327,    -1,   280,   281,   327,
      -1,   258,   282,   325,    -1,   283,    62,   325,    -1,   284,
     285,   325,    -1,   286,   183,   209,   325,    -1,   185,   289,
     325,    -1,   137,   515,    -1,    -1,    -1,   507,   505,   314,
      -1,    -1,   316,   507,   317,    -1,   504,   369,   508,   506,
      -1,   329,    -1,   290,   327,    -1,   291,   327,    -1,   292,
     327,    -1,   287,   289,   325,    -1,   288,   289,   325,    -1,
      -1,    -1,   513,   511,   314,    -1,    -1,   316,   513,   317,
      -1,   510,   514,   512,    -1,   359,   293,    -1,   516,   360,
     316,    -1,   517,   361,   314,    -1,   517,   294,   325,   314,
      -1,   517,   101,   325,   314,    -1,   517,   295,   325,   314,
      -1,   517,   296,    62,   325,   314,    -1,   517,   297,    62,
     325,   314,    -1,   517,   249,   518,   314,    -1,   517,   380,
     314,    -1,   517,   304,   306,   314,    -1,   517,   304,   173,
     314,    -1,   517,   304,   305,   314,    -1,   517,    74,   524,
     314,    -1,   302,    -1,   303,    -1,    78,    -1,   240,    -1,
     298,    -1,   299,    -1,   300,    -1,   301,    -1,    -1,   187,
     325,    -1,   271,   519,    -1,    -1,   521,   520,   314,    -1,
      -1,   316,   521,   317,    -1,    -1,   523,   369,   522,    -1,
     359,   309,    -1,   525,   360,   316,    -1,   526,   361,   314,
      -1,   526,   257,   258,   327,   314,    -1,   526,   530,   314,
      -1,   115,   329,    -1,   181,   328,    -1,   528,   266,   325,
      -1,   528,    -1,   529,   528,    -1,   527,   181,   328,    -1,
     527,   181,    19,    -1,   527,   311,   529,    -1,   527,   214,
      -1,   527,   132,    -1,   527,   310,    -1,   112,   309,   389,
       3,    -1,   314,    -1,   326,    -1,   334,    -1,   340,    -1,
     343,    -1,   353,    -1,   355,    -1,   358,    -1,   534,    -1,
     364,    -1,   417,    -1,   419,    -1,   429,    -1,   344,    -1,
     345,    -1,   346,    -1,   385,    -1,   386,    -1,   387,    -1,
     388,    -1,   390,    -1,   391,    -1,   392,    -1,   395,    -1,
     396,    -1,   397,    -1,   398,    -1,   399,    -1,   400,    -1,
     401,    -1,   402,    -1,   403,    -1,   406,    -1,   407,    -1,
     408,    -1,   409,    -1,   410,    -1,   411,    -1,   412,    -1,
     413,    -1,   414,    -1,   490,    -1,   491,    -1,   492,    -1,
     493,    -1,   494,    -1,   495,    -1,   496,    -1,   497,    -1,
     531,    -1,   535,   317,    -1,   536,   317,    -1,   371,   317,
      -1,   460,   317,    -1,   462,   317,    -1,   499,   317,    -1,
     503,   317,    -1,   517,   317,    -1,   526,   317,    -1,   348,
     360,   316,    -1,   535,   361,   314,    -1,   535,   349,   314,
      -1,   535,   352,   314,    -1,   350,   360,   316,    -1,   536,
     361,   314,    -1,   536,   351,   314,    -1,   111,    -1,     5,
      -1,   196,    -1,   193,    -1,   197,    -1,   195,    -1,   194,
      -1,   198,    -1,   199,    -1,   200,    -1,   219,    -1,   220,
      -1,   226,    -1,   227,    -1,   228,    -1,   229,    -1,   307,
      -1,   308,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   400,   400,   401,   404,   406,   413,   414,   415,   419,
     423,   432,   433,   434,   435,   436,   437,   443,   444,   451,
     458,   459,   463,   467,   474,   482,   483,   489,   498,   499,
     503,   508,   509,   513,   514,   518,   519,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   537,   538,   547,   548,
     549,   550,   553,   554,   555,   556,   560,   567,   570,   573,
     577,   578,   586,   602,   603,   607,   614,   620,   633,   637,
     650,   662,   668,   669,   670,   681,   683,   685,   689,   690,
     691,   692,   699,   707,   711,   717,   723,   725,   729,   730,
     731,   732,   733,   734,   735,   736,   740,   741,   742,   743,
     747,   755,   756,   764,   772,   773,   774,   778,   779,   783,
     788,   789,   796,   805,   806,   807,   811,   820,   826,   827,
     828,   832,   833,   837,   838,   839,   840,   841,   842,   848,
     849,   850,   854,   855,   859,   860,   866,   867,   870,   872,
     876,   877,   881,   899,   900,   901,   902,   903,   904,   912,
     915,   918,   921,   925,   926,   929,   932,   935,   939,   945,
     951,   958,   963,   968,   973,   977,   981,   991,   999,  1003,
    1010,  1011,  1014,  1018,  1020,  1022,  1024,  1026,  1028,  1030,
    1033,  1039,  1040,  1041,  1045,  1046,  1052,  1054,  1056,  1058,
    1060,  1062,  1066,  1070,  1073,  1077,  1078,  1079,  1083,  1084,
    1085,  1093,  1093,  1103,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1137,  1148,  1149,  1156,  1157,
    1164,  1173,  1177,  1181,  1205,  1206,  1210,  1223,  1223,  1239,
    1240,  1243,  1244,  1248,  1251,  1260,  1264,  1265,  1266,  1267,
    1271,  1277,  1283,  1289,  1295,  1301,  1308,  1313,  1321,  1322,
    1326,  1333,  1334,  1335,  1336,  1343,  1344,  1347,  1348,  1353,
    1365,  1366,  1370,  1371,  1375,  1376,  1377,  1378,  1379,  1383,
    1384,  1385,  1389,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1409,  1410,  1411,  1412,  1422,  1426,  1449,  1483,  1485,  1486,
    1487,  1488,  1489,  1490,  1491,  1495,  1496,  1497,  1498,  1499,
    1500,  1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,
    1510,  1512,  1513,  1514,  1516,  1518,  1520,  1522,  1523,  1524,
    1525,  1526,  1536,  1537,  1538,  1539,  1540,  1545,  1568,  1569,
    1570,  1571,  1572,  1573,  1577,  1580,  1581,  1582,  1591,  1598,
    1607,  1608,  1612,  1618,  1628,  1637,  1643,  1648,  1655,  1660,
    1666,  1667,  1668,  1676,  1678,  1679,  1680,  1686,  1708,  1709,
    1710,  1711,  1712,  1718,  1719,  1720,  1721,  1722,  1723,  1724,
    1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,
    1745,  1746,  1747,  1748,  1749,  1750,  1751,  1761,  1772,  1773,
    1777,  1778,  1779,  1780,  1781,  1782,  1785,  1796,  1799,  1801,
    1805,  1806,  1807,  1808,  1809,  1810,  1814,  1815,  1819,  1827,
    1829,  1833,  1834,  1835,  1839,  1840,  1843,  1845,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1861,
    1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,
    1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,
    1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1914,
    1916,  1920,  1921,  1923,  1932,  1942,  1944,  1948,  1949,  1951,
    1960,  1971,  1991,  1993,  1996,  1998,  2002,  2006,  2007,  2011,
    2014,  2017,  2022,  2025,  2030,  2033,  2036,  2042,  2050,  2051,
    2052,  2057,  2058,  2064,  2072,  2073,  2074,  2077,  2079,  2083,
    2087,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2115,  2133,  2135,  2138,  2140,  2144,  2147,  2160,
    2161,  2162,  2163,  2164,  2168,  2173,  2175,  2178,  2180,  2184,
    2190,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,
    2206,  2207,  2208,  2209,  2213,  2214,  2215,  2220,  2221,  2222,
    2223,  2224,  2227,  2228,  2229,  2232,  2234,  2237,  2239,  2243,
    2252,  2259,  2266,  2267,  2268,  2269,  2272,  2281,  2288,  2295,
    2296,  2300,  2304,  2310,  2313,  2314,  2315,  2318,  2325,  2325,
    2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,
    2325,  2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,
    2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,
    2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,
    2326,  2326,  2326,  2326,  2326,  2326,  2326,  2326,  2327,  2327,
    2327,  2327,  2327,  2327,  2327,  2327,  2327,  2328,  2328,  2328,
    2328,  2329,  2329,  2329,  2330,  2331,  2331,  2332,  2333,  2334,
    2335,  2336,  2337,  2338,  2339,  2340,  2341,  2341,  2341,  2341,
    2341,  2341
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM",
  "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'", "'>'",
  "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE", "ON",
  "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO",
  "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "ASYNC", "TABLE", "ROUTER", "ID", "PROTOCOL", "PREFERENCE", "DISABLED",
  "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES",
  "FILTERS", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP", "V6ONLY", "DUAL",
  "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "RELOAD", "IN", "OUT",
  "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS",
  "NEIGHBORS", "ATTRIBUTES", "ECHO", "DISABLE", "ENABLE", "RESTART",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "IF", "THEN", "ELSE", "CASE",
  "TRUE", "FALSE", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST",
  "DEST", "LEN", "DEFINED", "ADD", "DELETE", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "MATCH", "EMPTY", "WHERE", "EVAL", "LOCAL",
  "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP",
  "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC",
  "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES", "LIMIT",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD",
  "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT",
  "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "CHECK", "LINK", "RX", "BUFFER", "LARGE", "NORMAL", "STUBNET", "LSADB",
  "ECMP", "WEIGHT", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "MIN", "MAX", "RA", "INTERVAL", "MANAGED",
  "OTHER", "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT",
  "VALID", "PREFERRED", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RIP",
  "INFINITY", "PERIOD", "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "'('", "')'",
  "';'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "expr", "definition", "bool", "ipa", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "newtab", "proto_start", "proto_name", "proto_item", "imexport",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "set_item", "set_items", "fprefix_s", "fprefix", "fprefix_set",
  "switch_body", "bgp_path_expr", "bgp_path", "bgp_path_tail1",
  "bgp_path_tail2", "dpair", "constant", "rtadot", "function_call",
  "symbol", "static_attr", "term", "break_command", "print_one",
  "print_list", "var_listn", "var_list", "cmd", "bgp_proto_start",
  "bgp_proto", "ospf_proto_start", "ospf_proto", "ospf_proto_item",
  "ospf_area_start", "ospf_area", "ospf_area_opts", "ospf_area_item",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_el", "pref_hid", "ipa_list", "ipa_item", "ipa_el", "ipa_ne",
  "ospf_iface_start", "ospf_iface_opts", "ospf_iface_opt_list",
  "ospf_iface", "opttext", "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS",
  "cmd_SHOW_OSPF_INTERFACE", "cmd_SHOW_OSPF_TOPOLOGY",
  "cmd_SHOW_OSPF_TOPOLOGY_ALL", "cmd_SHOW_OSPF_STATE",
  "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB", "pipe_proto_start",
  "pipe_proto", "radv_proto_start", "radv_proto_item", "radv_proto_opts",
  "radv_proto", "radv_iface_start", "radv_iface_item", "radv_iface_finish",
  "radv_iface_opts", "radv_iface_opt_list", "radv_iface",
  "radv_prefix_start", "radv_prefix_item", "radv_prefix_finish",
  "radv_prefix_opts", "radv_prefix_opt_list", "radv_prefix",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,    61,    60,    62,   126,    43,    45,    42,    47,    37,
      33,    46,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,    40,    41,    59,    58,   123,   125,    44,    63,
      91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   322,   323,   323,   324,   324,   325,   325,   325,   326,
     326,   327,   327,   327,   327,   327,   327,   328,   328,   329,
     330,   330,   331,   331,   332,   333,   333,   334,   335,   335,
     336,   336,   336,   337,   337,   338,   338,   339,   339,   339,
     339,   339,   339,   339,   339,   339,   340,   340,   341,   341,
     341,   341,   342,   342,   342,   342,   343,   344,   345,   346,
     347,   347,   348,   349,   349,   349,   349,   350,   351,   351,
     352,   353,   354,   354,   354,   355,   356,   356,   357,   357,
     357,   357,   358,   359,   360,   360,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   362,   362,   362,   362,
     363,   364,   364,   365,   366,   366,   366,   367,   367,   368,
     369,   369,   370,   371,   371,   371,   372,   373,   374,   374,
     374,   375,   375,   376,   376,   376,   376,   376,   376,   377,
     377,   377,   378,   378,   379,   379,   380,   380,   381,   381,
     382,   382,   383,   384,   384,   384,   384,   384,   384,   385,
     386,   387,   388,   389,   389,   390,   391,   392,   393,   393,
     393,   393,   393,   393,   393,   393,   393,   393,   393,   393,
     394,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   404,   404,   405,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   415,   415,   416,   416,
     416,   418,   417,   419,   420,   420,   420,   420,   420,   420,
     420,   420,   420,   420,   420,   421,   422,   422,   423,   423,
     424,   425,   425,   426,   427,   427,   428,   430,   429,   431,
     431,   432,   432,   433,   433,   434,   435,   435,   435,   435,
     436,   436,   436,   436,   436,   436,   436,   436,   437,   437,
     438,   439,   439,   439,   439,   440,   440,   441,   441,   441,
     442,   442,   443,   443,   444,   444,   444,   444,   444,   445,
     445,   445,   446,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   448,   449,   450,   451,   451,   451,
     451,   451,   451,   451,   451,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   453,   453,
     453,   453,   453,   453,   454,   455,   455,   455,   456,   456,
     457,   457,   458,   458,   458,   458,   458,   458,   458,   458,
     458,   458,   458,   458,   458,   458,   458,   459,   460,   460,
     460,   460,   460,   460,   460,   460,   460,   460,   460,   460,
     460,   460,   460,   460,   460,   460,   460,   460,   460,   460,
     460,   460,   460,   460,   460,   460,   460,   460,   460,   460,
     460,   460,   460,   460,   460,   460,   460,   461,   462,   462,
     463,   463,   463,   463,   463,   463,   464,   465,   466,   466,
     467,   467,   467,   467,   467,   467,   468,   468,   469,   470,
     470,   471,   471,   471,   472,   472,   473,   473,   474,   474,
     474,   474,   474,   474,   474,   474,   474,   474,   474,   475,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   477,
     477,   478,   478,   479,   480,   481,   481,   482,   482,   483,
     484,   485,   486,   486,   487,   487,   488,   489,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   499,
     499,   499,   499,   500,   501,   501,   501,   502,   502,   503,
     504,   505,   505,   505,   505,   505,   505,   505,   505,   505,
     505,   505,   506,   507,   507,   508,   508,   509,   510,   511,
     511,   511,   511,   511,   512,   513,   513,   514,   514,   515,
     516,   517,   517,   517,   517,   517,   517,   517,   517,   517,
     517,   517,   517,   517,   518,   518,   518,   519,   519,   519,
     519,   519,   520,   520,   520,   521,   521,   522,   522,   523,
     524,   525,   526,   526,   526,   526,   527,   528,   528,   529,
     529,   530,   530,   530,   530,   530,   530,   531,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   534,   534,
     534,   534,   534,   534,   534,   534,   534,   535,   535,   535,
     535,   536,   536,   536,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     2,     0,
       1,     2,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     1,     1,
       1,     1,     2,     4,     3,     3,     3,     3,     4,     2,
       0,     1,     2,     2,     3,     2,     3,     2,     3,     3,
       3,     4,     1,     1,     1,     4,     0,     2,     2,     2,
       1,     1,     2,     1,     0,     1,     0,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     1,     1,     1,
       1,     3,     3,     0,     1,     1,     2,     0,     1,     3,
       1,     3,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     3,     3,     2,     2,
       1,     1,     4,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     1,     1,     0,     1,     3,     3,     3,     3,
       4,     4,     4,     4,     2,     1,     1,     1,     1,     0,
       1,     0,     4,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       5,     8,    12,     5,     5,     5,     1,     4,     1,     3,
       3,     1,     2,     2,     6,     1,     3,     0,     4,     3,
       1,     3,     3,     3,     2,     2,     2,     2,     0,     2,
       2,     0,     5,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     1,     1,     0,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       4,     1,     1,     1,     1,     2,     2,     3,     3,     6,
       3,     3,     3,     3,     6,     6,     6,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     2,     3,     3,
       5,     6,     6,     6,     4,     4,     5,     6,     6,     5,
       3,     4,     5,     5,     5,     5,     4,     4,     5,     5,
       5,     5,     5,     5,     6,     6,     8,     6,     6,     5,
       4,     5,     4,     5,     4,     5,     5,     2,     3,     3,
       1,     2,     2,     4,     2,     1,     2,     4,     0,     3,
       3,     2,     4,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     4,     1,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     2,     3,     2,     3,
       3,     4,     2,     2,     2,     3,     3,     3,     1,     0,
       2,     1,     1,     2,     3,     0,     2,     1,     1,     2,
       3,     0,     0,     3,     0,     3,     3,     1,     0,     4,
       6,     6,     6,     7,     6,     7,     6,     2,     3,     3,
       5,     4,     4,     2,     1,     2,     2,     0,     3,     4,
       0,     4,     4,     3,     2,     3,     3,     3,     3,     4,
       3,     2,     0,     0,     3,     0,     3,     4,     1,     2,
       2,     2,     3,     3,     0,     0,     3,     0,     3,     3,
       2,     3,     3,     4,     4,     4,     5,     5,     4,     3,
       4,     4,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     2,     0,     3,     0,     3,     0,
       3,     2,     3,     3,     5,     3,     2,     2,     3,     1,
       2,     3,     3,     3,     2,     2,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,   284,   588,   589,
     590,   591,   592,    84,    84,   593,   594,   595,     0,   597,
      84,    86,   598,   599,   600,    84,    86,    84,    86,    84,
      86,    84,     0,    84,    86,    84,    86,     5,   596,    86,
      86,   195,   197,   196,     0,    61,    60,     0,    59,     0,
       0,     0,     0,   194,   199,     0,     0,     0,   158,   154,
     154,   154,     0,     0,     0,     0,     0,     0,     0,   183,
     182,   181,   184,     0,     0,     0,     0,    30,    29,    32,
       0,     0,     0,    51,    50,    49,    48,     0,     0,    82,
       0,   201,    76,     0,     0,   227,   268,   273,   282,   279,
     235,   286,   276,     0,     0,   271,   284,   314,   274,   275,
       0,     0,     0,     0,   284,     0,   277,   278,   283,   313,
     312,     0,   311,   203,    85,     0,     0,    62,    67,   112,
     357,   397,   497,   503,   540,   571,     0,     0,     0,     0,
       0,    16,   116,     0,     0,     0,     0,   640,     0,     0,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,     0,     0,     0,     0,     0,   641,     0,
       0,     0,    16,     0,    16,   642,   400,     0,     0,   405,
       0,     0,     0,   643,     0,     0,   644,     0,   569,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   645,     0,
       0,   137,   141,     0,     0,     0,   646,     0,     0,     0,
       0,    16,     0,    16,     0,   638,     0,     0,     0,     0,
      26,   639,     0,     0,   119,   118,     0,     0,     0,    57,
       0,     0,   189,   130,   129,     0,     0,   198,   200,   199,
       0,   155,     0,   150,   149,     0,   153,     0,   154,   154,
     154,   154,   154,     0,     0,   178,   179,   175,   173,   174,
     176,   177,   185,     0,   186,   187,   188,     0,     0,    31,
      33,     0,     0,   101,     6,     8,   284,   102,    52,     0,
      56,    72,    73,    74,     0,   216,     0,    47,     0,     0,
     268,   286,   268,   284,   268,   268,     0,   260,     0,   284,
       0,     0,   271,   271,     0,   309,   284,   284,   284,   284,
       0,   239,   237,   284,   236,   238,   246,   248,     0,   251,
     255,     0,   655,   287,   654,   288,   289,   290,   291,   292,
     293,   294,   657,   660,   659,   656,   658,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   315,   316,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,     0,   647,   651,   113,    89,   100,    93,
       0,    87,    12,    14,    13,    15,    11,    88,   103,    98,
     216,    99,   284,    91,    97,    92,    95,    90,   114,   115,
     358,     0,     0,     0,     0,     0,     0,     0,    16,     0,
      17,    18,     0,     0,     0,     0,     0,     0,   370,     0,
       0,     0,     0,     0,    16,     0,     0,     0,     0,    16,
       0,    16,     0,    16,     0,    16,     0,     0,   359,   398,
     406,   401,   404,   402,   399,   408,   498,     0,     0,     0,
     499,   507,   541,   103,     0,   142,     0,   138,   556,   554,
     555,     0,     0,     0,     0,     0,     0,     0,     0,   542,
     549,   143,   572,     0,   576,    16,   573,   585,     0,   584,
     586,     0,   575,     0,    63,     0,    65,    16,   649,   650,
     648,     0,    25,     0,   653,   652,   124,   123,   125,   127,
     128,   126,     0,   121,   192,    58,   190,   191,   134,   135,
       0,   132,   193,     0,   151,   156,   157,   164,     0,     0,
     171,   216,   165,   168,   169,     0,   170,   159,     0,   163,
     172,   488,   488,   488,   154,   488,   154,   488,   489,   587,
     180,     0,     0,    28,    37,    38,    39,    40,    41,    42,
      43,    44,    45,     0,    35,    27,     0,     0,    54,    55,
      71,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,     0,     0,     0,   202,   220,    80,    81,     0,     0,
      75,    77,    46,     0,   216,   264,   265,     0,   266,   267,
     262,   250,   338,   341,     0,   322,   323,   269,   270,   263,
       0,     0,     0,     0,   295,   284,   273,   286,     0,   284,
       0,     0,     0,   280,   252,   253,     0,     0,   281,   307,
     305,   303,   300,   301,   302,   304,   306,   308,   296,   297,
     298,   299,   317,     0,   318,   320,   321,    94,   107,   110,
     117,   221,   222,    96,   223,     0,     0,   392,   394,     0,
      16,    16,     0,     0,     0,     0,     0,     0,     0,     0,
     371,     0,     0,     0,     0,     0,     0,   364,     0,   365,
       0,   390,     0,     0,     0,     0,     0,     0,     0,   376,
     377,     0,     0,     0,   501,   502,    86,   567,   553,   544,
       0,     0,   548,   543,   545,     0,     0,   551,   552,   550,
       0,     0,     0,     0,     0,     0,    19,     0,   582,   581,
       0,   579,   583,    70,    64,    66,    68,    21,    20,    69,
     120,     0,   131,     0,   152,   161,   167,   162,   160,   166,
     487,     0,     0,     0,   488,     0,   488,     0,    10,     9,
      34,     0,     7,    53,   215,   214,   216,   284,    78,    79,
     225,   218,     0,   228,   261,   284,   327,   310,   284,   284,
     284,     0,     0,     0,     0,     0,   235,   249,     0,     0,
     256,   284,   108,     0,   103,     0,     0,   393,     0,     0,
     389,   383,   360,     0,     0,   366,     0,   369,     0,   372,
     382,   381,   378,     0,     0,   391,   380,   373,   374,   375,
     395,   396,   379,   403,   481,    16,     0,     0,     0,   407,
       0,   415,   425,   500,   510,     0,   504,     0,   565,   570,
     136,   138,   546,   547,     0,     0,     0,     0,     0,   140,
      22,    23,   574,   577,     0,   580,   122,   133,   491,   490,
     496,     0,   492,     0,   494,    36,   217,     0,   331,     0,
     332,   333,     0,   284,   329,   330,   328,   284,   284,     0,
     284,     0,     0,   284,   231,   224,     0,   339,     0,     0,
       0,   272,     0,     0,   295,     0,     0,   247,     0,     0,
     104,   105,   109,   111,   385,     0,   387,   388,   361,   362,
     368,   367,   384,   363,   103,   414,     0,   411,   469,     0,
     418,   413,   417,   409,   426,   103,   506,   528,   537,   505,
     508,   562,   139,   143,    24,     0,     0,     0,     0,   578,
     493,   495,   284,   284,   284,   284,     0,     0,     0,   226,
     232,     0,     0,   351,   334,   336,     0,   219,   325,   326,
     324,   243,   245,   244,     0,   240,     0,   319,   106,     0,
     484,   410,     0,   439,   419,   428,   525,   535,   534,     0,
       0,   568,     0,   148,   143,   143,   143,   143,     0,     0,
       0,     0,   345,   284,   257,   284,   284,     0,   284,   350,
       0,     0,   254,   386,   482,   486,   412,     0,   470,   471,
     472,     0,     0,     0,     0,     0,     0,     0,   424,   438,
       0,   523,   522,     0,   539,   563,   557,   558,   559,   560,
     561,   564,   566,   144,   145,   146,   147,   344,   285,   348,
       0,   284,   342,   233,     0,     0,     0,     0,     0,     0,
       0,   337,     0,     0,     0,     0,   473,    16,     0,    16,
     416,     0,   432,   430,   429,     0,     0,   433,   435,   436,
     437,   427,     0,   527,     0,     0,    16,    16,    16,   538,
       0,     0,     0,   284,   284,   352,     0,   347,   346,   284,
     284,   284,   353,   241,     0,     0,     0,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   485,   468,     0,   474,   422,   423,   421,   420,   431,
     434,     0,     0,     0,     0,     0,    16,     0,     0,     0,
       0,   526,     0,     0,     0,   529,   530,   531,   536,   349,
     234,   343,   259,   284,     0,     0,     0,     0,   475,   444,
     458,   440,   443,   441,     0,   456,     0,   445,   447,   448,
     449,   450,   451,   452,   453,   454,   462,   463,   464,    16,
     442,    16,     0,     0,   483,   521,     0,     0,     0,     0,
       0,   514,    16,     0,     0,     0,   524,   532,   533,   258,
       0,     0,     0,     0,     0,   455,   446,   457,   459,   465,
     466,   467,   460,   520,   516,   513,     0,     0,   515,   517,
     518,     0,   355,   356,   354,     0,     0,   461,   476,   477,
     478,   511,   512,   519,   242,     0,   479,   480
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   446,    69,   447,   533,   778,   779,   766,
     975,   553,    70,   339,   140,   342,   613,   614,    71,   147,
     148,    72,    16,    17,    18,   107,    73,   286,    74,   292,
     287,    75,   354,    76,   356,   641,    77,    78,   185,   208,
     453,   439,    79,   698,   942,   833,   699,   700,    80,    81,
     448,   209,   297,   562,   563,   306,   570,   571,   270,   750,
     271,   272,   763,    19,    20,    21,    22,   317,    23,    24,
      25,   315,   588,    26,    27,    28,    29,    30,    31,    32,
      33,    34,   132,   333,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   104,   310,    82,   355,    83,   631,   632,
     633,   812,   702,   703,   454,   644,   635,    84,   359,   919,
     920,  1082,   176,   386,   387,   388,   177,   390,   391,  1084,
     365,   178,   366,   374,   179,   180,   181,   922,   182,   418,
     652,   923,   995,   996,   653,   654,   924,    85,    86,    87,
      88,   247,   248,   249,   742,   870,   961,   962,  1051,  1101,
     871,  1015,  1060,   872,  1153,  1012,  1048,  1049,  1050,  1234,
    1258,  1259,  1260,   954,  1094,  1045,   955,   791,    44,    45,
      46,    47,    48,    49,    50,    51,    89,    90,    91,   877,
     746,    92,   965,  1172,  1113,  1112,  1062,   966,   968,  1120,
    1064,  1063,  1018,   969,    93,    94,   521,  1071,  1022,   971,
     879,   513,   514,    95,    96,   278,   771,   772,   279,    52,
      97,    53,    98,    99,   100,   419
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -892
static const yytype_int16 yypact[] =
{
      55,   657,    85,   510,   406,   370,   100,   553,   406,   189,
     433,   470,   357,   406,   406,   406,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,   250,   537,   170,   371,
     285,    30,  -892,   289,   275,    18,   366,   875,  -892,  -892,
    -892,  -892,  -892,   376,   376,  -892,  -892,  -892,   810,  -892,
     376,   339,  -892,  -892,  -892,   376,  1454,   376,   862,   376,
     198,   376,    60,   376,  1499,   376,  1578,  -892,  -892,  1619,
    1425,  -892,  -892,  -892,     9,  -892,   393,   418,  -892,   406,
     406,   454,   187,  -892,   526,   108,   463,   492,  -892,   425,
     166,   425,   516,   548,   559,   563,   600,   612,   644,  -892,
    -892,  -892,   434,   647,   649,   652,   640,  -892,   621,  -892,
      -7,     9,    22,  -892,  -892,  -892,  -892,   245,   365,  -892,
     679,  -892,  -892,   372,   187,  -892,    20,  -892,  -892,  -892,
     656,   394,  -892,   547,   549,    17,   875,  -892,  -892,  -892,
     417,   426,   429,   431,   875,    58,  -892,  -892,  -892,  -892,
    -892,  1396,  -892,  1889,  -892,   437,   447,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,   449,     9,   727,   699,
      22,   120,  -892,    81,    81,   751,   187,  -892,   472,   473,
     484,    70,   782,   120,   593,   613,    90,   706,    53,   303,
     745,   634,   750,    32,   641,   632,   276,   630,   629,   213,
     617,   614,   120,   620,   619,   607,    -1,    62,  -892,   522,
     521,   679,   120,    22,   120,  -892,  -892,   525,   532,  -892,
     536,   784,   210,  -892,   541,   540,  -892,   542,  -892,   838,
      22,   551,   -15,    22,    22,   806,   808,  -132,  -892,   557,
     558,  -892,   560,   564,   303,   615,  -892,   561,   402,   565,
     817,   120,   820,   120,   821,  -892,   571,   582,   583,   833,
     880,  -892,   594,   595,  -892,  -892,   896,   912,   913,  -892,
     914,   918,  -892,  -892,  -892,   314,   919,  -892,  -892,   535,
     923,  -892,   924,  -892,  -892,  1771,  -892,   925,   425,   425,
     425,   265,   360,   929,   936,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,   937,  -892,  -892,  -892,    75,   922,  -892,
    -892,   907,   631,  -892,  -892,  -892,   875,  -892,    22,   528,
    -892,  -892,  -892,  -892,   643,  1744,   -21,  -892,   645,   646,
      20,  -892,    20,   875,    20,    20,   949,  -892,   917,   623,
     941,   944,    17,    17,   939,   946,   875,   875,   875,   875,
     105,  -892,  -892,   648,  -892,  -892,   947,  -892,   181,    35,
    -892,   220,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
     875,   875,   875,   875,   875,   875,   875,   875,   875,   875,
     875,   875,   875,   581,  -892,  -892,  -892,  -892,  -892,  -892,
     679,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    1670,  -892,   875,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,   921,   926,   665,   666,    22,   945,   770,   120,   303,
    -892,  -892,    22,   825,   829,    22,   927,    22,  -892,   677,
     933,   822,    22,    22,   120,   942,   693,   940,   696,   120,
     697,   120,    96,   120,   727,   120,   698,   708,  -892,  -892,
    -892,  -892,  -892,   811,  -892,  -892,  -892,  1008,   713,   714,
    -892,  -892,  -892,  -892,   716,  -892,   719,   957,  -892,  -892,
    -892,   725,   729,   730,    22,    22,   731,   732,   734,  -892,
    -892,   186,  -892,    37,  -892,   120,  -892,  -892,   590,  -892,
    -892,   860,  -892,    22,  -892,    22,  -892,   120,  -892,  -892,
    -892,    22,  -892,   303,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,   315,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
     432,  -892,  -892,  1044,  -892,  -892,  -892,  -892,  1031,  1033,
    -892,  1670,  -892,  -892,  -892,   303,  -892,  -892,  1035,  -892,
    -892,  1045,  1045,  1045,   425,  1045,   425,  1045,  -892,  -892,
    -892,   749,   754,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,   440,  -892,  -892,  1175,  1053,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,    64,   759,   761,  -892,  -892,  -892,  -892,   303,    22,
    -892,  -892,  -892,  1593,  1744,  -892,  -892,  1200,  -892,  -892,
    -892,  -892,   222,  -892,   765,  -892,  -892,  -892,  -892,  -892,
    1225,   428,   453,   501,  -892,   875,   762,   182,   767,   875,
     771,  1052,   132,  -892,  -892,  -892,  1072,  1071,  -892,   768,
     768,   768,  1900,  1900,   768,   768,   768,   768,   192,   192,
     946,   946,  -892,   778,  -892,  -892,  -892,  -892,  1067,  -892,
     783,  -892,  -892,  -892,  1889,    22,    22,  -892,  -892,   788,
     120,   120,   792,   793,   794,    22,    22,   804,    22,   812,
    -892,    22,   814,   816,   818,   830,    22,  -892,   679,  -892,
     844,  -892,   845,   854,   857,   859,   861,   863,   864,  -892,
    -892,    22,   242,   866,  -892,  -892,  1644,  -199,  -892,  -892,
     826,   867,  -892,  -892,  -892,   874,   876,  -892,  -892,  -892,
      22,   347,   422,   872,    22,   303,  -892,   877,  -892,  -892,
     303,   865,   860,  -892,  -892,  -892,  -892,    37,  -892,  -892,
    -892,   896,  -892,   314,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  1126,  1131,  1173,  1045,  1189,  1045,  1190,  -892,  -892,
    -892,   907,  -892,  -892,  -892,  -892,  1744,   733,  -892,  -892,
    -892,  -892,   280,  -892,  -892,   875,  -892,  -892,   875,   875,
     875,  1250,   173,   154,   175,   153,  -892,  -892,   886,   656,
    -892,   875,  -892,   602,  -892,   891,   894,  -892,   899,   900,
    -892,  -892,  -892,   901,   902,  -892,   903,  -892,   904,  -892,
    -892,  -892,  -892,   905,   906,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,    73,   878,   971,   303,  -892,
     916,  -892,   938,  -892,  -892,   303,  -892,   930,  -892,  -892,
    -892,   957,  -892,  -892,   931,  1218,  1218,  1218,  1218,  -892,
    -892,  -892,  -892,  -892,    22,   865,  -892,  -892,  -892,  -892,
    -892,  1235,  -892,  1236,  -892,  -892,  -892,    41,  -892,  1219,
    -892,  -892,   943,   875,  -892,  -892,  -892,   875,   875,   948,
      12,  1396,   950,   673,  -892,  -892,  1744,  -892,  1275,  1300,
    1325,  -892,   953,   954,   952,   955,    36,  -892,  1227,  1350,
     303,  -892,  -892,  -892,  -892,    22,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,    22,  -892,  -892,   679,
    -892,  -892,   963,  -892,  -892,  -892,  -892,  -892,   972,  -892,
    -892,  -119,  -892,   186,  -892,   973,   975,   977,   978,  -892,
    -892,  -892,   875,   623,   875,  -892,   700,  1846,   603,  -892,
    -892,  1221,   359,  -892,  1889,   976,   979,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  1212,  1231,   987,  -892,  -892,   981,
     215,  -892,     5,  -892,  -892,  1188,   221,  -892,  -892,    22,
     345,  -892,   991,  -892,   186,   186,   186,   186,   819,   999,
    1089,  1169,  -892,  1024,  -892,   875,   875,   435,   673,  -892,
      22,  1232,  -892,  -892,  -892,  -892,  -892,   -58,  -892,  -892,
    -892,   281,    22,    22,    22,  1124,   176,   -14,  -892,  -892,
    1000,  -892,  -892,   445,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    1002,   733,  1170,  -892,    38,  1114,  1139,  1004,  1006,  1007,
    1015,  -892,  1017,  1025,  1587,  1027,  -892,   120,    22,   120,
    -892,  1028,  -892,  -892,  -892,    22,    22,  -892,  -892,  -892,
    -892,  -892,  1480,  -892,  1049,  1050,   120,   120,   120,  -892,
    1029,  1030,  1003,  1024,    80,  -892,  1039,  -892,  -892,   875,
     875,   875,  -892,  -892,    22,  1054,    22,   120,    22,    22,
      22,  1156,    22,   240,   815,    -9,  1113,    22,  1122,  1123,
    1116,  -892,  -892,  1070,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,   303,  1096,  1104,  -105,  1110,   120,  1118,  1338,  1117,
    1229,  -892,  1099,    22,    22,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,    80,  1383,  1408,  1433,  1102,  -892,  -892,
    -892,  -892,  -892,  -892,    22,  -892,    22,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   120,
    -892,   120,    86,    22,  -892,  -892,    22,    22,    22,  1143,
    1147,  -892,   120,    22,    22,  1237,  -892,  -892,  -892,  -892,
    1133,  1134,  1135,    22,    28,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,    22,    22,  -892,  -892,
    -892,    22,  -892,  -892,  -892,  1125,  -115,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  1136,  -892,  -892
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -892,  -892,  -892,  -142,  -892,  -193,  -210,  -273,  -571,  -892,
    -218,  -892,  -892,  -892,  -892,  -892,  -892,   626,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  1339,  -892,  -892,  -892,  -892,
    -892,  -892,  -239,  -892,  -892,  -892,  -892,  -892,   928,   -75,
    1247,   958,  -892,  -892,  -892,  -892,   628,  -507,  -892,  -892,
    -892,  -892,   111,  -892,   682,    29,  -892,   683,  -891,   586,
    -505,  -892,  -457,  -892,  -892,  -892,  -892,  -104,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,   264,  1159,  -892,  -892,  -892,  -892,  -608,
     663,  -892,  1115,   890,  1157,  -892,   831,  -892,  -892,  -743,
    -892,   350,  -171,   654,  -665,  -892,  -170,   797,  -892,  -892,
    -892,  -892,   340,   387,  -892,  -892,  -797,  -892,    40,   562,
     -64,  -892,  -892,   442,   667,   498,  -696,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -303,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,   323,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,   715,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -755
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -510
static const yytype_int16 yytable[] =
{
     347,   534,   500,   183,   385,   389,   747,   827,   473,   474,
     921,   239,   751,   246,   788,   254,   323,   324,  -230,   269,
     464,   277,   470,   471,   288,   293,  -230,  -230,  -230,  -230,
     907,   372,   340,   384,   360,   811,   344,   153,   361,   490,
     345,   526,   587,   294,  1124,  1256,   344,   362,   295,   501,
     345,   503,   344,   381,   382,   826,   345,   908,   441,     1,
     674,   675,   982,   518,  1108,   764,   494,  1004,  1019,  1206,
     470,   471,   344,   381,   382,   160,   345,   636,   637,   638,
     639,   479,   804,   909,  1218,    54,  -229,   344,   544,   344,
     546,   345,   601,   345,  -229,  -229,  -229,  -229,   907,   150,
     344,   502,   375,   108,   345,   154,   442,   443,   444,   445,
     380,   311,   420,   421,   422,   423,   424,   878,   516,   834,
     449,   522,   523,   921,  1059,   908,   425,   426,   427,   428,
     429,   430,   431,   432,   344,   496,   433,  1265,   345,   910,
     911,   912,   913,   914,   915,   916,   344,   381,   382,   826,
     345,   909,  1020,   442,   443,   444,   445,   917,   450,   451,
     918,   420,   421,   422,   423,   424,   992,   344,   381,   382,
     826,   345,  1219,   527,   528,   425,   426,   427,   428,   429,
     430,   431,   432,   358,   316,   433,   495,   344,  1031,   344,
     344,   345,   113,   345,   345,   602,   367,  1095,  1021,  1266,
     932,   697,   935,  1152,   805,   467,   617,   910,   911,   912,
     913,   914,   915,   916,   591,   592,   593,   595,   597,   431,
     432,   303,   312,   433,   990,   917,   304,   472,   918,   420,
     421,   422,   423,   424,  1109,   457,   921,  1110,   197,  1207,
     318,   670,  1208,   425,   426,   427,   428,   429,   430,   431,
     432,   452,   343,   433,   344,   760,  1096,   141,   345,   713,
     461,   462,   941,   142,   348,   198,   199,  1106,   136,   200,
     201,   111,   112,   203,   204,   712,  1080,   133,   134,   135,
     733,   761,   616,   316,   921,   497,   319,   519,   520,   792,
     793,   725,   795,   640,   797,   468,   730,   349,   732,   647,
     736,   205,   738,   149,   594,   206,   956,   151,   437,   341,
     734,   735,   660,   661,   662,   663,   864,   762,   997,   616,
     470,   471,  1046,   709,  -230,   296,   921,   921,   769,  -230,
     714,  1196,   363,   717,   346,   719,   373,  1083,  1122,   364,
     723,   724,   767,   777,   346,  1257,   478,  1239,  1240,  1005,
     383,   676,   765,   983,   775,  1125,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,  1008,
     383,   129,   152,   300,   301,   777,   751,   256,   316,   197,
    1036,  1182,   755,   756,   155,   346,   921,   346,   704,   105,
    1037,   130,  -229,   568,   184,  1097,   131,  -229,   346,   596,
     367,   773,   367,   774,   367,   367,   198,   199,   143,   776,
     200,   201,   105,   202,   203,   204,   486,   487,   664,  1126,
     106,   299,   569,   665,   101,   102,   144,  1083,   808,   885,
     320,   886,   346,   321,   322,   420,   421,   422,   423,   424,
    1229,   145,   205,   316,   383,   103,   206,  1010,   332,   425,
     426,   427,   428,   429,   430,   431,   432,   302,  1016,   433,
     420,   421,   422,   423,   424,   346,   313,   934,   251,   252,
     482,   483,   665,   865,   425,   426,   427,   428,   429,   430,
     431,   432,   508,   509,   433,   346,   146,   346,   346,   854,
     794,   901,   796,   903,   369,   314,   866,   809,   867,   672,
      -8,   385,   673,   305,   887,   868,   888,   389,   420,   421,
     422,   423,   424,    55,  1098,   253,  1023,   838,   839,   325,
     114,   115,   425,   426,   427,   428,   429,   430,   431,   432,
     384,  1044,   433,   834,   537,   122,  1099,  1061,   677,   834,
     815,   678,    56,   116,   307,   308,   117,    57,   118,   119,
      58,   326,   346,   307,   308,   891,   137,   123,   124,   869,
     893,    59,   327,   835,   836,   309,   328,  1073,  1074,  1075,
    1076,   101,   102,   843,   844,   138,   846,    60,    61,   848,
      62,   618,   619,   538,   853,  1066,   139,    63,   125,   126,
     127,   128,   103,   925,   926,   960,  1087,  1088,  1100,   863,
    1089,   821,   967,   329,  1090,   823,    64,   470,   471,   768,
     420,   421,   422,   423,   424,   330,   539,    65,   884,   470,
     471,   940,   890,   777,   425,   426,   427,   428,   429,   430,
     431,   432,   780,   781,   433,   156,    66,   157,   158,   159,
     160,   161,   162,  1067,  1068,  1069,  1070,   331,   163,   164,
     334,   165,   335,   166,   385,   336,   207,   120,   109,   110,
     156,   337,   666,   158,   159,   160,   667,   162,   976,   977,
     978,   876,   957,   163,   164,   668,   165,   338,   166,   350,
     933,    67,   936,   384,   368,   156,   357,   157,   158,   159,
     160,   161,   162,   351,   167,   352,   353,     4,   163,   164,
     645,   165,   646,   166,   648,   649,   369,   420,   421,   422,
     423,   424,   540,   541,     5,     6,   370,   692,   371,   167,
    1013,   425,   426,   427,   428,   429,   430,   431,   432,   376,
     777,   433,  1114,  1115,   693,  1116,  1117,  1118,   377,  1047,
     694,   378,   121,   379,   167,   438,   818,   695,   696,   782,
     783,   907,   979,   434,   928,   929,   930,   800,   801,   657,
     658,     7,  1119,   435,     8,   436,     9,   939,   440,    10,
     456,   819,   168,   169,    11,  -510,  -510,  -510,   908,    12,
      13,    14,    15,   170,   171,   172,   458,   459,   173,  -510,
    -510,  -510,  -510,   429,   430,   431,   432,   168,   169,   433,
     460,   463,   465,  1009,   909,   466,   469,   475,   170,   171,
     172,   476,   477,   173,  1011,   481,   480,   484,   485,   820,
     488,   489,   168,   169,    68,   493,   420,   421,   422,   423,
     424,   491,   492,   170,   171,   172,   498,   499,   173,   504,
     425,   426,   427,   428,   429,   430,   431,   432,   505,   986,
     433,   507,   506,   987,   988,   510,   511,   515,   512,   994,
     910,   911,   912,   913,   914,   915,   916,   517,   524,   187,
     525,   529,   530,   535,   188,   536,   531,  1065,   917,   542,
     532,   918,   545,   189,   543,   548,   547,   156,   967,   157,
     158,   159,   160,   161,   162,   551,   549,   550,  1092,   552,
     163,   164,   197,   165,  1155,   166,  1157,   190,   554,   555,
    1102,  1103,  1104,   385,  1107,   564,   565,   566,  1028,  1034,
    1030,   567,   572,  1175,  1176,  1177,   574,   575,   590,   198,
     199,   651,   598,   200,   201,   174,  -340,   203,   204,   599,
     600,   603,   384,   175,  1190,   615,   167,   604,   605,   606,
     607,   608,   609,   610,   611,   612,  1156,   620,   643,   642,
     669,   556,   650,  1159,  1160,   205,   655,   659,   175,   206,
     656,  1085,  1086,  1221,   994,   557,   558,   433,   671,   707,
     708,   559,   560,   705,   561,   174,   711,  -335,   706,   718,
     710,   720,  1187,   175,  1189,   721,  1191,  1192,  1193,   715,
    1195,  1197,   186,   716,   726,  1210,   722,   727,   196,   728,
     729,   731,   739,   210,  1032,   240,  1237,   250,  1238,   255,
     741,   257,   740,   273,   168,   169,   743,   744,   745,  1248,
     748,  1227,  1228,   749,   191,   170,   171,   172,   259,   752,
     173,   770,   907,   753,   754,   757,   758,   784,   759,   785,
    -229,   786,  1235,   789,  1236,  1198,  1199,  1200,  1201,  1202,
    1203,  1204,  1205,   798,   790,  1184,  1185,  1186,   799,   908,
    1241,  1242,   803,   806,  1243,  1244,  1245,   807,   816,   192,
      -6,  1249,  1250,   825,   193,   822,   828,   241,   829,   824,
     831,  1255,   242,   832,   243,   909,   420,   421,   422,   423,
     424,   834,   837,   194,  1261,  1262,   840,   841,   842,  1263,
     425,   426,   427,   428,   429,   430,   431,   432,   845,   195,
     433,   420,   421,   422,   423,   424,   847,   244,   849,   898,
     850,   894,   851,  1077,   899,   425,   426,   427,   428,   429,
     430,   431,   432,   880,   852,   433,   420,   421,   422,   423,
     424,   910,   911,   912,   913,   914,   915,   916,   855,   856,
     425,   426,   427,   428,   429,   430,   431,   432,   857,   917,
     433,   858,   918,   859,   392,   860,   900,   861,   862,   245,
     873,   881,   420,   421,   422,   423,   424,   174,   882,   889,
     883,   892,   902,   904,   958,   175,   425,   426,   427,   428,
     429,   430,   431,   432,   938,   944,   433,   420,   421,   422,
     423,   424,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   425,   426,   427,   428,   429,   430,   431,   432,   959,
     963,   433,   420,   421,   422,   423,   424,   974,   980,   981,
     984,  1006,  1035,  1040,   970,   973,   425,   426,   427,   428,
     429,   430,   431,   432,   964,   985,   433,   420,   421,   422,
     423,   424,  1041,  1093,   993,   989,  1001,  1002,  1003,   259,
      -7,   425,   426,   427,   428,   429,   430,   431,   432,  1014,
     394,   433,   420,   421,   422,   423,   424,  1024,  1017,  1025,
     261,  1026,  1027,  1039,  1038,  1043,   425,   426,   427,   428,
     429,   430,   431,   432,  1042,  1072,   433,   420,   421,   422,
     423,   424,  1078,  1105,  1111,  1121,  1129,  1123,  1130,  1131,
    1180,   425,   426,   427,   428,   429,   430,   431,   432,  1132,
    1133,   433,   420,   421,   422,   423,   424,  1134,  1173,  1174,
    1081,  1154,  1158,  1178,  1179,  1194,   425,   426,   427,   428,
     429,   430,   431,   432,  1183,  1209,   433,   420,   421,   422,
     423,   424,   402,   403,   404,   405,   406,   407,   408,   409,
    1188,   425,   426,   427,   428,   429,   430,   431,   432,  1052,
    1211,   433,  1213,  1212,  1214,  1216,  1217,  1220,   410,   411,
     420,   421,   422,   423,   424,   412,   413,   414,   415,  1222,
    1223,   392,  1224,  1079,   425,   426,   427,   428,   429,   430,
     431,   432,  1225,  1226,   433,   420,   421,   422,   423,   424,
    1233,  1246,  1053,  1054,  1055,  1247,  1056,   905,  1127,   425,
     426,   427,   428,   429,   430,   431,   432,  1057,  1264,   433,
     420,   421,   422,   423,   424,   298,  1251,  1252,  1253,  1254,
    1267,   455,   737,  1128,   425,   426,   427,   428,   429,   430,
     431,   432,   943,   896,   433,   197,   897,   972,   573,   906,
     634,   787,   589,  1181,   830,   813,   416,   417,   393,   937,
    1091,  1029,   927,   991,  1215,     0,   289,   895,   802,     0,
       0,     0,   198,   199,   197,     0,   200,   201,     0,   211,
     203,   204,     0,     0,     0,  1058,     0,   394,     0,     0,
       0,     0,     0,   814,   290,     0,     0,     0,     0,     0,
       0,   198,   199,     0,     0,   200,   201,     0,   205,   203,
     204,     0,   206,     0,     0,   212,     0,   213,   817,   197,
       0,     0,     0,     0,     0,     0,     0,   395,   396,     0,
     397,   398,   399,   400,   401,     0,     0,   205,     0,     0,
       0,   206,     0,   931,     0,     0,   198,   199,     0,   214,
     200,   201,     0,   258,   203,   204,     0,   215,   216,     0,
     259,     0,     0,     0,     0,     0,     0,     0,   998,   402,
     403,   404,   405,   406,   407,   408,   409,     0,     0,     0,
     260,   261,   205,     0,     0,     0,   206,     0,     0,   217,
       0,     0,     0,   999,     0,   410,   411,  1161,   197,     0,
       0,     0,   412,   413,   414,   415,   218,   219,     0,   220,
     221,     0,   222,   223,   224,     0,   225,     0,  1000,   226,
     227,     0,   228,     0,     0,   198,   199,     0,     0,   200,
     201,     0,     0,   203,   204,   229,   230,     0,     0,   197,
     231,     0,   232,  1007,   233,  1162,   234,     0,   259,     0,
       0,   235,     0,     0,     0,   236,   237,     0,   280,   281,
     282,   205,   283,   284,   197,   206,   198,   199,   701,   261,
     200,   201,     0,   274,   203,   204,  1230,     0,     0,     0,
       0,     0,     0,   416,   417,     0,     0,  1135,     0,     0,
       0,   198,   199,     0,     0,   200,   201,     0,   874,   203,
     204,  1231,   205,     0,     0,     0,   206,   621,   622,   623,
     624,   625,   626,     0,   627,   628,   629,   630,  1163,     0,
       0,     0,   291,     0,     0,     0,  1232,   205,   262,     0,
       0,   206,     0,     0,     0,  1164,  1165,     0,     0,  1166,
    1167,     0,     0,  1168,  1169,     0,  1170,     0,     0,     0,
       0,   238,     0,     0,   576,     0,     0,     0,  1136,     0,
       0,   875,     0,     0,     0,     0,     0,     0,   470,   471,
       0,     0,     0,   263,   264,   265,   266,  1171,     0,     0,
       0,     0,     0,   267,   621,   622,   623,   624,   625,   626,
     577,   627,   628,   629,   630,     0,   268,     0,  1137,     0,
    1138,  1139,  1140,  1141,  1142,  1143,  1144,     0,     0,     0,
       0,     0,     0,     0,     0,   275,  1145,  1146,   578,     0,
    1147,   579,     0,     0,  1148,     0,  1149,   580,   581,     0,
       0,     0,  1150,   420,   421,   422,   423,   424,     0,     0,
     582,   583,   584,   585,     0,   586,     0,   425,   426,   427,
     428,   429,   430,   431,   432,     0,     0,   433,   621,   622,
     623,   624,   625,   626,     0,   627,   628,   629,   630,     0,
       0,     0,     0,     0,     0,   276,   420,   421,   422,   423,
     424,     0,     0,     0,  1151,     0,   810,   420,   421,   422,
     425,   426,   427,   428,   429,   430,   431,   432,     0,     0,
     433,   425,   426,   427,   428,   429,   430,   431,   432,     0,
       0,   433,     0,     0,     0,     0,   285,     0,     0,     0,
       0,   452,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -509,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1033
};

static const yytype_int16 yycheck[] =
{
     142,   274,   241,    67,   175,   175,   513,   672,   218,   219,
     807,    86,   517,    88,   585,    90,   120,   121,     6,    94,
     213,    96,    17,    18,    99,   100,    14,    15,    16,    17,
      18,    14,    39,   175,    14,   643,    14,    19,    18,   232,
      18,   173,   315,    34,     6,    17,    14,    27,    39,   242,
      18,   244,    14,    15,    16,    17,    18,    45,   200,     4,
      25,    26,    21,    78,    78,    28,    67,    31,   187,    78,
      17,    18,    14,    15,    16,    17,    18,    98,    99,   100,
     101,   223,    18,    71,   189,     0,     6,    14,   281,    14,
     283,    18,    17,    18,    14,    15,    16,    17,    18,    69,
      14,   243,   166,     3,    18,    87,    33,    34,    35,    36,
     174,     3,     7,     8,     9,    10,    11,   316,   260,   318,
      39,   263,   264,   920,  1015,    45,    21,    22,    23,    24,
      25,    26,    27,    28,    14,    73,    31,   252,    18,   127,
     128,   129,   130,   131,   132,   133,    14,    15,    16,    17,
      18,    71,   271,    33,    34,    35,    36,   145,    77,    78,
     148,     7,     8,     9,    10,    11,   921,    14,    15,    16,
      17,    18,   277,   305,   306,    21,    22,    23,    24,    25,
      26,    27,    28,   154,    18,    31,   187,    14,   985,    14,
      14,    18,     3,    18,    18,   337,   156,   255,   317,   314,
      27,   440,    27,  1094,   140,   115,   348,   127,   128,   129,
     130,   131,   132,   133,   318,   319,   320,   321,   322,    27,
      28,    34,   114,    31,   920,   145,    39,   174,   148,     7,
       8,     9,    10,    11,   248,   206,  1033,   251,    40,   248,
      74,   383,   251,    21,    22,    23,    24,    25,    26,    27,
      28,   170,   141,    31,    14,    69,   314,    87,    18,   469,
     190,   191,   833,    93,    19,    67,    68,    91,    18,    71,
      72,     7,     8,    75,    76,   468,  1031,    13,    14,    15,
     184,    95,   346,    18,  1081,   223,   120,   302,   303,   592,
     593,   484,   595,   314,   597,   205,   489,    52,   491,   363,
     493,   103,   495,    18,    39,   107,   233,    18,   197,   316,
     214,   215,   376,   377,   378,   379,    74,   131,   926,   383,
      17,    18,   317,   465,   312,   316,  1123,  1124,   538,   317,
     472,    91,   312,   475,   312,   477,   319,  1033,  1081,   319,
     482,   483,   535,   553,   312,   317,   314,   261,   262,   313,
     312,   316,   315,   312,   547,   317,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   940,
     312,    14,    97,   109,   110,   585,   881,   317,    18,    40,
      21,  1124,   524,   525,    18,   312,  1183,   312,   452,    19,
      31,    34,   312,    79,    18,   114,    39,   317,   312,    39,
     360,   543,   362,   545,   364,   365,    67,    68,    37,   551,
      71,    72,    19,    74,    75,    76,   203,   204,   313,  1084,
      50,     3,   108,   318,    18,    19,    55,  1123,   638,    82,
     264,    84,   312,   267,   268,     7,     8,     9,    10,    11,
    1183,    70,   103,    18,   312,    39,   107,   954,    14,    21,
      22,    23,    24,    25,    26,    27,    28,     3,   965,    31,
       7,     8,     9,    10,    11,   312,     3,   313,   270,   271,
     194,   195,   318,   231,    21,    22,    23,    24,    25,    26,
      27,    28,   272,   273,    31,   312,   115,   312,   312,   728,
     594,   794,   596,   796,   312,     3,   254,   639,   256,   318,
     318,   672,   321,   316,    82,   263,    84,   677,     7,     8,
       9,    10,    11,     3,   233,   317,   973,   710,   711,     3,
      87,    88,    21,    22,    23,    24,    25,    26,    27,    28,
     672,   316,    31,   318,   132,    65,   255,   316,   318,   318,
     318,   321,    32,   110,    18,    19,   113,    37,   115,   116,
      40,     3,   312,    18,    19,   765,    19,    87,    88,   317,
     770,    51,     3,   705,   706,    39,     3,  1024,  1025,  1026,
    1027,    18,    19,   715,   716,    38,   718,    67,    68,   721,
      70,    53,    54,   181,   726,   240,    49,    77,   118,   119,
     120,   121,    39,   313,   314,   868,   161,   162,   317,   741,
     165,   665,   875,     3,   169,   669,    96,    17,    18,    19,
       7,     8,     9,    10,    11,     3,   214,   107,   760,    17,
      18,    19,   764,   833,    21,    22,    23,    24,    25,    26,
      27,    28,   317,   318,    31,    12,   126,    14,    15,    16,
      17,    18,    19,   298,   299,   300,   301,     3,    25,    26,
       3,    28,     3,    30,   825,     3,   317,   224,   105,   106,
      12,    21,    14,    15,    16,    17,    18,    19,   886,   887,
     888,   746,   865,    25,    26,    27,    28,    56,    30,   314,
     822,   171,   824,   825,    28,    12,   314,    14,    15,    16,
      17,    18,    19,    14,    71,    16,    17,    40,    25,    26,
     360,    28,   362,    30,   364,   365,   312,     7,     8,     9,
      10,    11,   310,   311,    57,    58,   169,   136,   169,    71,
     959,    21,    22,    23,    24,    25,    26,    27,    28,   312,
     940,    31,   287,   288,   153,   290,   291,   292,   312,  1012,
     159,   312,   309,   312,    71,    18,   318,   166,   167,   317,
     318,    18,   894,   316,   818,   819,   820,   317,   318,   372,
     373,   104,   317,   316,   107,   316,   109,   831,    69,   112,
      19,   318,   149,   150,   117,     7,     8,     9,    45,   122,
     123,   124,   125,   160,   161,   162,   314,   314,   165,    21,
      22,    23,    24,    25,    26,    27,    28,   149,   150,    31,
     316,    19,   209,   945,    71,   192,   100,    62,   160,   161,
     162,   177,    62,   165,   956,   183,   175,   187,   189,   318,
     203,   207,   149,   150,   314,   218,     7,     8,     9,    10,
      11,   211,   213,   160,   161,   162,   314,   316,   165,   314,
      21,    22,    23,    24,    25,    26,    27,    28,   316,   913,
      31,    67,   316,   917,   918,   314,   316,    19,   316,   923,
     127,   128,   129,   130,   131,   132,   133,   316,    62,    59,
      62,   314,   314,   258,    64,   314,   316,  1019,   145,   314,
     316,   148,    62,    73,    67,   314,    65,    12,  1161,    14,
      15,    16,    17,    18,    19,    62,   314,   314,  1040,    19,
      25,    26,    40,    28,  1097,    30,  1099,    97,   314,   314,
    1052,  1053,  1054,  1084,  1056,     3,     3,     3,   982,   316,
     984,     3,     3,  1116,  1117,  1118,     3,     3,     3,    67,
      68,    14,     3,    71,    72,   312,   313,    75,    76,     3,
       3,    19,  1084,   320,  1137,   314,    71,    40,    41,    42,
      43,    44,    45,    46,    47,    48,  1098,   314,   312,   314,
     312,    65,    13,  1105,  1106,   103,    25,    28,   320,   107,
      26,  1035,  1036,  1166,  1038,    79,    80,    31,    31,   314,
     314,    85,    86,    62,    88,   312,   216,   314,    62,    62,
      45,   314,  1134,   320,  1136,    62,  1138,  1139,  1140,   174,
    1142,  1143,    74,   174,    62,  1147,   184,   314,    80,    69,
     314,   314,   314,    85,   314,    87,  1209,    89,  1211,    91,
     209,    93,   314,    95,   149,   150,    18,   314,   314,  1222,
     314,  1173,  1174,   314,   224,   160,   161,   162,    81,   314,
     165,   181,    18,   314,   314,   314,   314,     3,   314,    18,
     317,    18,  1194,    18,  1196,   240,   241,   242,   243,   244,
     245,   246,   247,   314,    19,  1129,  1130,  1131,   314,    45,
    1212,  1213,    19,   314,  1216,  1217,  1218,   316,   313,   269,
     318,  1223,  1224,    31,   274,   318,    14,   225,    17,   318,
     312,  1233,   230,    26,   232,    71,     7,     8,     9,    10,
      11,   318,   314,   293,  1246,  1247,   314,   314,   314,  1251,
      21,    22,    23,    24,    25,    26,    27,    28,   314,   309,
      31,     7,     8,     9,    10,    11,   314,   265,   314,     3,
     314,   266,   314,   314,     3,    21,    22,    23,    24,    25,
      26,    27,    28,   317,   314,    31,     7,     8,     9,    10,
      11,   127,   128,   129,   130,   131,   132,   133,   314,   314,
      21,    22,    23,    24,    25,    26,    27,    28,   314,   145,
      31,   314,   148,   314,     5,   314,     3,   314,   314,   317,
     314,   314,     7,     8,     9,    10,    11,   312,   314,   317,
     314,   314,     3,     3,   316,   320,    21,    22,    23,    24,
      25,    26,    27,    28,   318,   314,    31,     7,     8,     9,
      10,    11,   318,   314,   314,   314,   314,   314,   314,   314,
     314,    21,    22,    23,    24,    25,    26,    27,    28,   258,
     314,    31,     7,     8,     9,    10,    11,    19,     3,     3,
      21,    14,    21,    31,   314,   314,    21,    22,    23,    24,
      25,    26,    27,    28,   316,   312,    31,     7,     8,     9,
      10,    11,    31,    31,   314,   317,   313,   313,   313,    81,
     318,    21,    22,    23,    24,    25,    26,    27,    28,   316,
     111,    31,     7,     8,     9,    10,    11,   314,   316,   314,
     102,   314,   314,   314,   318,   314,    21,    22,    23,    24,
      25,    26,    27,    28,   317,   314,    31,     7,     8,     9,
      10,    11,   313,   189,   314,   313,   312,   147,   312,   312,
     317,    21,    22,    23,    24,    25,    26,    27,    28,   314,
     313,    31,     7,     8,     9,    10,    11,   312,   289,   289,
     316,   314,   314,   314,   314,   189,    21,    22,    23,    24,
      25,    26,    27,    28,   315,   242,    31,     7,     8,     9,
      10,    11,   193,   194,   195,   196,   197,   198,   199,   200,
     316,    21,    22,    23,    24,    25,    26,    27,    28,   191,
     258,    31,   266,   260,   314,   289,   282,   277,   219,   220,
       7,     8,     9,    10,    11,   226,   227,   228,   229,   281,
      62,     5,   285,   314,    21,    22,    23,    24,    25,    26,
      27,    28,   183,   314,    31,     7,     8,     9,    10,    11,
     318,   278,   234,   235,   236,   278,   238,   801,   314,    21,
      22,    23,    24,    25,    26,    27,    28,   249,   313,    31,
       7,     8,     9,    10,    11,   106,   209,   314,   314,   314,
     314,   204,   494,   314,    21,    22,    23,    24,    25,    26,
      27,    28,   834,   781,    31,    40,   783,   881,   309,   806,
     355,   581,   315,  1123,   677,   644,   307,   308,    82,   825,
    1038,   983,   815,   921,  1161,    -1,    61,   772,   313,    -1,
      -1,    -1,    67,    68,    40,    -1,    71,    72,    -1,    45,
      75,    76,    -1,    -1,    -1,   317,    -1,   111,    -1,    -1,
      -1,    -1,    -1,   313,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    71,    72,    -1,   103,    75,
      76,    -1,   107,    -1,    -1,    81,    -1,    83,   313,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,   152,    -1,
     154,   155,   156,   157,   158,    -1,    -1,   103,    -1,    -1,
      -1,   107,    -1,   313,    -1,    -1,    67,    68,    -1,   115,
      71,    72,    -1,    74,    75,    76,    -1,   123,   124,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   313,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,   155,
      -1,    -1,    -1,   313,    -1,   219,   220,   137,    40,    -1,
      -1,    -1,   226,   227,   228,   229,   172,   173,    -1,   175,
     176,    -1,   178,   179,   180,    -1,   182,    -1,   313,   185,
     186,    -1,   188,    -1,    -1,    67,    68,    -1,    -1,    71,
      72,    -1,    -1,    75,    76,   201,   202,    -1,    -1,    40,
     206,    -1,   208,   313,   210,   185,   212,    -1,    81,    -1,
      -1,   217,    -1,    -1,    -1,   221,   222,    -1,    59,    60,
      61,   103,    63,    64,    40,   107,    67,    68,    18,   102,
      71,    72,    -1,   115,    75,    76,   313,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,    -1,    -1,   120,    -1,    -1,
      -1,    67,    68,    -1,    -1,    71,    72,    -1,    74,    75,
      76,   313,   103,    -1,    -1,    -1,   107,   134,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   258,    -1,
      -1,    -1,   317,    -1,    -1,    -1,   313,   103,   249,    -1,
      -1,   107,    -1,    -1,    -1,   275,   276,    -1,    -1,   279,
     280,    -1,    -1,   283,   284,    -1,   286,    -1,    -1,    -1,
      -1,   317,    -1,    -1,     3,    -1,    -1,    -1,   191,    -1,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      -1,    -1,    -1,   294,   295,   296,   297,   317,    -1,    -1,
      -1,    -1,    -1,   304,   134,   135,   136,   137,   138,   139,
      39,   141,   142,   143,   144,    -1,   317,    -1,   231,    -1,
     233,   234,   235,   236,   237,   238,   239,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   257,   249,   250,    67,    -1,
     253,    70,    -1,    -1,   257,    -1,   259,    76,    77,    -1,
      -1,    -1,   265,     7,     8,     9,    10,    11,    -1,    -1,
      89,    90,    91,    92,    -1,    94,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    31,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,    -1,
      -1,    -1,    -1,    -1,    -1,   317,     7,     8,     9,    10,
      11,    -1,    -1,    -1,   317,    -1,   313,     7,     8,     9,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    -1,
      31,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      -1,    31,    -1,    -1,    -1,    -1,   317,    -1,    -1,    -1,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   146
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   323,   324,    40,    57,    58,   104,   107,   109,
     112,   117,   122,   123,   124,   125,   344,   345,   346,   385,
     386,   387,   388,   390,   391,   392,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   490,   491,   492,   493,   494,   495,
     496,   497,   531,   533,     0,     3,    32,    37,    40,    51,
      67,    68,    70,    77,    96,   107,   126,   171,   314,   326,
     334,   340,   343,   348,   350,   353,   355,   358,   359,   364,
     370,   371,   417,   419,   429,   459,   460,   461,   462,   498,
     499,   500,   503,   516,   517,   525,   526,   532,   534,   535,
     536,    18,    19,    39,   415,    19,    50,   347,     3,   105,
     106,   415,   415,     3,    87,    88,   110,   113,   115,   116,
     224,   309,    65,    87,    88,   118,   119,   120,   121,    14,
      34,    39,   404,   415,   415,   415,    18,    19,    38,    49,
     336,    87,    93,    37,    55,    70,   115,   341,   342,    18,
      69,    18,    97,    19,    87,    18,    12,    14,    15,    16,
      17,    18,    19,    25,    26,    28,    30,    71,   149,   150,
     160,   161,   162,   165,   312,   320,   434,   438,   443,   446,
     447,   448,   450,   452,    18,   360,   360,    59,    64,    73,
      97,   224,   269,   274,   293,   309,   360,    40,    67,    68,
      71,    72,    74,    75,    76,   103,   107,   317,   361,   373,
     360,    45,    81,    83,   115,   123,   124,   155,   172,   173,
     175,   176,   178,   179,   180,   182,   185,   186,   188,   201,
     202,   206,   208,   210,   212,   217,   221,   222,   317,   361,
     360,   225,   230,   232,   265,   317,   361,   463,   464,   465,
     360,   270,   271,   317,   361,   360,   317,   360,    74,    81,
     101,   102,   249,   294,   295,   296,   297,   304,   317,   361,
     380,   382,   383,   360,   115,   257,   317,   361,   527,   530,
      59,    60,    61,    63,    64,   317,   349,   352,   361,    61,
      89,   317,   351,   361,    34,    39,   316,   374,   347,     3,
     415,   415,     3,    34,    39,   316,   377,    18,    19,    39,
     416,     3,   114,     3,     3,   393,    18,   389,    74,   120,
     264,   267,   268,   389,   389,     3,     3,     3,     3,     3,
       3,     3,    14,   405,     3,     3,     3,    21,    56,   335,
      39,   316,   337,   374,    14,    18,   312,   325,    19,    52,
     314,    14,    16,    17,   354,   418,   356,   314,   377,   430,
      14,    18,    27,   312,   319,   442,   444,   450,    28,   312,
     169,   169,    14,   319,   445,   452,   312,   312,   312,   312,
     452,    15,    16,   312,   325,   434,   435,   436,   437,   438,
     439,   440,     5,    82,   111,   151,   152,   154,   155,   156,
     157,   158,   193,   194,   195,   196,   197,   198,   199,   200,
     219,   220,   226,   227,   228,   229,   307,   308,   451,   537,
       7,     8,     9,    10,    11,    21,    22,    23,    24,    25,
      26,    27,    28,    31,   316,   316,   316,   374,    18,   363,
      69,   325,    33,    34,    35,    36,   325,   327,   372,    39,
      77,    78,   170,   362,   426,   362,    19,   377,   314,   314,
     316,   190,   191,    19,   327,   209,   192,   115,   205,   100,
      17,    18,   174,   328,   328,    62,   177,    62,   314,   325,
     175,   183,   194,   195,   187,   189,   203,   204,   203,   207,
     327,   211,   213,   218,    67,   187,    73,   223,   314,   316,
     354,   327,   325,   327,   314,   316,   316,    67,   272,   273,
     314,   316,   316,   523,   524,    19,   325,   316,    78,   302,
     303,   518,   325,   325,    62,    62,   173,   305,   306,   314,
     314,   316,   316,   328,   329,   258,   314,   132,   181,   214,
     310,   311,   314,    67,   327,    62,   327,    65,   314,   314,
     314,    62,    19,   333,   314,   314,    65,    79,    80,    85,
      86,    88,   375,   376,     3,     3,     3,     3,    79,   108,
     378,   379,     3,   416,     3,     3,     3,    39,    67,    70,
      76,    77,    89,    90,    91,    92,    94,   329,   394,   426,
       3,   389,   389,   389,    39,   389,    39,   389,     3,     3,
       3,    17,   325,    19,    40,    41,    42,    43,    44,    45,
      46,    47,    48,   338,   339,   314,   452,   325,    53,    54,
     314,   134,   135,   136,   137,   138,   139,   141,   142,   143,
     144,   420,   421,   422,   424,   428,    98,    99,   100,   101,
     314,   357,   314,   312,   427,   444,   444,   452,   444,   444,
      13,    14,   452,   456,   457,    25,    26,   445,   445,    28,
     452,   452,   452,   452,   313,   318,    14,    18,    27,   312,
     325,    31,   318,   321,    25,    26,   316,   318,   321,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   136,   153,   159,   166,   167,   354,   365,   368,
     369,    18,   424,   425,   452,    62,    62,   314,   314,   325,
      45,   216,   327,   328,   325,   174,   174,   325,    62,   325,
     314,    62,   184,   325,   325,   327,    62,   314,    69,   314,
     327,   314,   327,   184,   214,   215,   327,   363,   327,   314,
     314,   209,   466,    18,   314,   314,   502,   369,   314,   314,
     381,   382,   314,   314,   314,   325,   325,   314,   314,   314,
      69,    95,   131,   384,    28,   315,   331,   327,    19,   328,
     181,   528,   529,   325,   325,   327,   325,   328,   329,   330,
     317,   318,   317,   318,     3,    18,    18,   425,   330,    18,
      19,   489,   489,   489,   389,   489,   389,   489,   314,   314,
     317,   318,   313,    19,    18,   140,   314,   316,   328,   325,
     313,   421,   423,   428,   313,   318,   313,   313,   318,   318,
     318,   452,   318,   452,   318,    31,    17,   436,    14,    17,
     439,   312,    26,   367,   318,   325,   325,   314,   327,   327,
     314,   314,   314,   325,   325,   314,   325,   314,   325,   314,
     314,   314,   314,   325,   354,   314,   314,   314,   314,   314,
     314,   314,   314,   325,    74,   231,   254,   256,   263,   317,
     467,   472,   475,   314,    74,   137,   361,   501,   316,   522,
     317,   314,   314,   314,   325,    82,    84,    82,    84,   317,
     325,   328,   314,   328,   266,   528,   376,   379,     3,     3,
       3,   489,     3,   489,     3,   339,   422,    18,    45,    71,
     127,   128,   129,   130,   131,   132,   133,   145,   148,   431,
     432,   448,   449,   453,   458,   313,   314,   456,   452,   452,
     452,   313,    27,   325,   313,    27,   325,   435,   318,   452,
      19,   330,   366,   368,   314,   318,   314,   314,   314,   314,
     314,   314,   314,   314,   485,   488,   233,   327,   316,   258,
     329,   468,   469,   314,   316,   504,   509,   329,   510,   515,
     314,   521,   381,   314,    19,   332,   332,   332,   332,   325,
       3,     3,    21,   312,    21,   312,   452,   452,   452,   317,
     458,   451,   537,   314,   452,   454,   455,   421,   313,   313,
     313,   313,   313,   313,    31,   313,    14,   313,   330,   325,
     369,   325,   477,   354,   316,   473,   369,   316,   514,   187,
     271,   317,   520,   384,   314,   314,   314,   314,   452,   457,
     452,   448,   314,   146,   316,    21,    21,    31,   318,   314,
      31,    31,   317,   314,   316,   487,   317,   329,   478,   479,
     480,   470,   191,   234,   235,   236,   238,   249,   317,   380,
     474,   316,   508,   513,   512,   325,   240,   298,   299,   300,
     301,   519,   314,   384,   384,   384,   384,   314,   313,   314,
     537,   316,   433,   458,   441,   452,   452,   161,   162,   165,
     169,   455,   325,    31,   486,   255,   314,   114,   233,   255,
     317,   471,   325,   325,   325,   189,    91,   325,    78,   248,
     251,   314,   507,   506,   287,   288,   290,   291,   292,   317,
     511,   313,   431,   147,     6,   317,   436,   314,   314,   312,
     312,   312,   314,   313,   312,   120,   191,   231,   233,   234,
     235,   236,   237,   238,   239,   249,   250,   253,   257,   259,
     265,   317,   380,   476,   314,   327,   325,   327,   314,   325,
     325,   137,   185,   258,   275,   276,   279,   280,   283,   284,
     286,   317,   505,   289,   289,   327,   327,   327,   314,   314,
     317,   433,   431,   315,   452,   452,   452,   325,   316,   325,
     327,   325,   325,   325,   189,   325,    91,   325,   240,   241,
     242,   243,   244,   245,   246,   247,    78,   248,   251,   242,
     325,   258,   260,   266,   314,   515,   289,   282,   189,   277,
     277,   327,   281,    62,   285,   183,   314,   325,   325,   431,
     313,   313,   313,   318,   481,   325,   325,   327,   327,   261,
     262,   325,   325,   325,   325,   325,   278,   278,   327,   325,
     325,   209,   314,   314,   314,   325,    17,   317,   482,   483,
     484,   325,   325,   325,   313,   252,   314,   314
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 400 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 401 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 414 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 415 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 419 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 423 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 432 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 433 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 434 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 435 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 436 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 437 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 444 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 451 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 459 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 463 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 467 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 474 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 482 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 483 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 489 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 498 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 499 "cf-parse.y"
    { (yyval.t) = bird_name; ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 503 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 508 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 509 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 513 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 514 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 518 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 519 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 523 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 524 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 525 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 526 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 527 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 528 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 529 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 530 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 531 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 537 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); ;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 538 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 547 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; ;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 548 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; ;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 549 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; ;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 550 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 553 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; ;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 554 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 555 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 556 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 568 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 571 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 574 "cf-parse.y"
    { cmd_shutdown(); ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 577 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 586 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 602 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 603 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 607 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 614 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 620 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 633 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 637 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 650 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 662 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 668 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 670 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 689 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 690 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 691 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 692 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 699 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 711 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 717 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 725 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 729 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 730 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 731 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 732 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 733 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 734 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 735 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 736 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 740 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 742 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 743 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 747 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 755 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 756 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 764 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 772 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 773 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 774 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 778 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 779 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 796 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 811 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 826 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 827 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 828 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 833 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 837 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 838 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 839 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 840 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 841 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 842 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 848 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 849 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 850 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 855 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 859 "cf-parse.y"
    { (yyval.i) = MD_STATES; ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 860 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 881 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 899 "cf-parse.y"
    { ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 900 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 901 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 902 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 903 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 904 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 913 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 916 "cf-parse.y"
    { cmd_show_memory(); ;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 919 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); ;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 922 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); ;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 926 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 930 "cf-parse.y"
    { if_show(); ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 933 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 936 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 939 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 945 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 951 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 958 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 963 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 968 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 973 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 977 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 981 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 991 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 999 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 1003 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1010 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1011 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1015 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1019 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1021 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1023 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1025 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1027 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1029 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1031 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1033 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1039 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1040 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1045 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1046 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1053 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); ;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1055 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); ;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1057 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1059 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); ;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1061 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1063 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1067 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1071 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1074 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); ;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1077 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1078 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1083 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1084 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1085 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1093 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1094 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1103 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1107 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1108 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1109 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1110 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1111 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1112 "cf-parse.y"
    { (yyval.i) = T_QUAD; ;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1113 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1114 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1115 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1116 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1117 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1137 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1148 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1149 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1156 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1157 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1164 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1173 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1181 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1205 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1206 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1210 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1223 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1226 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1239 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1240 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; ;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1243 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); ;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1244 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); ;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 1248 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1251 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1260 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1264 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 1266 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 1267 "cf-parse.y"
    { (yyval.v).type = (yyvsp[(1) - (1)].i) >> 16; (yyval.v).val.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 1271 "cf-parse.y"
    {
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i)); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i));
   ;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 1277 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (8)].i), (yyvsp[(4) - (8)].i)); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(2) - (8)].i), (yyvsp[(7) - (8)].i));
   ;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 1283 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (12)].i), (yyvsp[(4) - (12)].i)); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(9) - (12)].i), (yyvsp[(11) - (12)].i));
   ;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 1289 "cf-parse.y"
    { 	/* This is probably useless :-) */
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = 0;
	(yyval.e)->to.val.i = 0xffffffff;
   ;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 1295 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (5)].i), 0); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(2) - (5)].i), 0xffff);
   ;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 1301 "cf-parse.y"
    { 
	(yyval.e) = f_generate_rev_wcard(0, 0xffff, (yyvsp[(4) - (5)].i));
   ;}
    break;

  case 246:

/* Line 1464 of yacc.c  */
#line 1308 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (1)].v); 
	(yyval.e)->to = (yyvsp[(1) - (1)].v);
   ;}
    break;

  case 247:

/* Line 1464 of yacc.c  */
#line 1313 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (4)].v); 
	(yyval.e)->to = (yyvsp[(4) - (4)].v); 
   ;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 1321 "cf-parse.y"
    { (yyval.e) = (yyvsp[(1) - (1)].e); ;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 1322 "cf-parse.y"
    { (yyval.e) = (yyvsp[(3) - (3)].e); (yyval.e)->left = (yyvsp[(1) - (3)].e); ;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 1326 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 1333 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 1334 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 1335 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 1336 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 1343 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 1344 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 1347 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 1348 "cf-parse.y"
    {
     (yyval.e) = (yyvsp[(2) - (4)].e);
     (yyval.e)->data = (yyvsp[(4) - (4)].x);
     (yyval.e)->left = (yyvsp[(1) - (4)].e);
   ;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 1353 "cf-parse.y"
    {
     (yyval.e) = f_new_tree(); 
     (yyval.e)->from.type = T_VOID; 
     (yyval.e)->to.type = T_VOID;
     (yyval.e)->data = (yyvsp[(3) - (3)].x);
     (yyval.e)->left = (yyvsp[(1) - (3)].e);
   ;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 1365 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 261:

/* Line 1464 of yacc.c  */
#line 1366 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 262:

/* Line 1464 of yacc.c  */
#line 1370 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 263:

/* Line 1464 of yacc.c  */
#line 1371 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 1375 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 265:

/* Line 1464 of yacc.c  */
#line 1376 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 266:

/* Line 1464 of yacc.c  */
#line 1377 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 1378 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 1379 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 269:

/* Line 1464 of yacc.c  */
#line 1383 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 1384 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 271:

/* Line 1464 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 1389 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = make_pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    ;}
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 1402 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 1403 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 1404 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 1405 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 1406 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 1407 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 1408 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 1409 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 281:

/* Line 1464 of yacc.c  */
#line 1410 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 1411 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 1412 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 1426 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 1449 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 1483 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 1485 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 1486 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 1487 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 1488 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 1489 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 1490 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 1491 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 1495 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 1496 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 1497 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 1498 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 1499 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 1500 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 1501 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 1502 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 1503 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 1504 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 1505 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 1506 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 1507 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 1508 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 1509 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 1510 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 1516 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 1520 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 1522 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 1523 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 1524 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 1525 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 1526 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 1536 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 1537 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 1538 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 1539 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 1540 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 1545 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 1568 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 1569 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 1570 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 1571 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 1572 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 1573 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 1577 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 1580 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 1581 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 1582 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 1591 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 1598 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 1607 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 1608 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 1612 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 1618 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 1628 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 1637 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 1643 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 1648 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 1655 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 1660 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 1666 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 1667 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 1668 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 1677 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; ;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 1678 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 355:

/* Line 1464 of yacc.c  */
#line 1679 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 356:

/* Line 1464 of yacc.c  */
#line 1680 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 357:

/* Line 1464 of yacc.c  */
#line 1686 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 ;}
    break;

  case 360:

/* Line 1464 of yacc.c  */
#line 1710 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 361:

/* Line 1464 of yacc.c  */
#line 1711 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); ;}
    break;

  case 362:

/* Line 1464 of yacc.c  */
#line 1712 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 363:

/* Line 1464 of yacc.c  */
#line 1718 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); ;}
    break;

  case 364:

/* Line 1464 of yacc.c  */
#line 1719 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 365:

/* Line 1464 of yacc.c  */
#line 1720 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 366:

/* Line 1464 of yacc.c  */
#line 1721 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 367:

/* Line 1464 of yacc.c  */
#line 1722 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 368:

/* Line 1464 of yacc.c  */
#line 1723 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 369:

/* Line 1464 of yacc.c  */
#line 1724 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 370:

/* Line 1464 of yacc.c  */
#line 1725 "cf-parse.y"
    { BGP_CFG->multihop = 64; ;}
    break;

  case 371:

/* Line 1464 of yacc.c  */
#line 1726 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); ;}
    break;

  case 372:

/* Line 1464 of yacc.c  */
#line 1727 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 373:

/* Line 1464 of yacc.c  */
#line 1728 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 374:

/* Line 1464 of yacc.c  */
#line 1729 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 375:

/* Line 1464 of yacc.c  */
#line 1730 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 376:

/* Line 1464 of yacc.c  */
#line 1731 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; ;}
    break;

  case 377:

/* Line 1464 of yacc.c  */
#line 1732 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; ;}
    break;

  case 378:

/* Line 1464 of yacc.c  */
#line 1733 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 379:

/* Line 1464 of yacc.c  */
#line 1734 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 380:

/* Line 1464 of yacc.c  */
#line 1735 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 381:

/* Line 1464 of yacc.c  */
#line 1736 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 382:

/* Line 1464 of yacc.c  */
#line 1737 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 383:

/* Line 1464 of yacc.c  */
#line 1738 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 384:

/* Line 1464 of yacc.c  */
#line 1739 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 385:

/* Line 1464 of yacc.c  */
#line 1740 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 386:

/* Line 1464 of yacc.c  */
#line 1741 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 1742 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 1743 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 1744 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 1745 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 1746 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 392:

/* Line 1464 of yacc.c  */
#line 1747 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 1748 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 394:

/* Line 1464 of yacc.c  */
#line 1749 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 1750 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); ;}
    break;

  case 396:

/* Line 1464 of yacc.c  */
#line 1751 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); ;}
    break;

  case 397:

/* Line 1464 of yacc.c  */
#line 1761 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 401:

/* Line 1464 of yacc.c  */
#line 1778 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 402:

/* Line 1464 of yacc.c  */
#line 1779 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; ;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 1780 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); ;}
    break;

  case 404:

/* Line 1464 of yacc.c  */
#line 1781 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 406:

/* Line 1464 of yacc.c  */
#line 1785 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 407:

/* Line 1464 of yacc.c  */
#line 1796 "cf-parse.y"
    { ospf_area_finish(); ;}
    break;

  case 410:

/* Line 1464 of yacc.c  */
#line 1805 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); ;}
    break;

  case 411:

/* Line 1464 of yacc.c  */
#line 1806 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;};}
    break;

  case 418:

/* Line 1464 of yacc.c  */
#line 1819 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 421:

/* Line 1464 of yacc.c  */
#line 1833 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 1834 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 1835 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 1839 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 429:

/* Line 1464 of yacc.c  */
#line 1849 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 430:

/* Line 1464 of yacc.c  */
#line 1850 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 431:

/* Line 1464 of yacc.c  */
#line 1851 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 1852 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 1853 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 434:

/* Line 1464 of yacc.c  */
#line 1854 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 1855 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 1856 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 437:

/* Line 1464 of yacc.c  */
#line 1857 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 439:

/* Line 1464 of yacc.c  */
#line 1862 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 1883 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 1884 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 1885 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 1886 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 1887 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 1888 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 1889 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 1890 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 1891 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 449:

/* Line 1464 of yacc.c  */
#line 1892 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 1893 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 451:

/* Line 1464 of yacc.c  */
#line 1894 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 452:

/* Line 1464 of yacc.c  */
#line 1895 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 453:

/* Line 1464 of yacc.c  */
#line 1896 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 454:

/* Line 1464 of yacc.c  */
#line 1897 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 455:

/* Line 1464 of yacc.c  */
#line 1898 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 456:

/* Line 1464 of yacc.c  */
#line 1899 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 1900 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 458:

/* Line 1464 of yacc.c  */
#line 1901 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 459:

/* Line 1464 of yacc.c  */
#line 1902 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); ;}
    break;

  case 460:

/* Line 1464 of yacc.c  */
#line 1903 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); ;}
    break;

  case 462:

/* Line 1464 of yacc.c  */
#line 1905 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 1906 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 464:

/* Line 1464 of yacc.c  */
#line 1907 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 465:

/* Line 1464 of yacc.c  */
#line 1908 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 466:

/* Line 1464 of yacc.c  */
#line 1909 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 467:

/* Line 1464 of yacc.c  */
#line 1910 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); ;}
    break;

  case 473:

/* Line 1464 of yacc.c  */
#line 1924 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 ;}
    break;

  case 474:

/* Line 1464 of yacc.c  */
#line 1933 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 ;}
    break;

  case 479:

/* Line 1464 of yacc.c  */
#line 1952 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 1961 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 481:

/* Line 1464 of yacc.c  */
#line 1971 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 486:

/* Line 1464 of yacc.c  */
#line 2002 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 488:

/* Line 1464 of yacc.c  */
#line 2007 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 489:

/* Line 1464 of yacc.c  */
#line 2012 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 490:

/* Line 1464 of yacc.c  */
#line 2015 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 491:

/* Line 1464 of yacc.c  */
#line 2018 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 492:

/* Line 1464 of yacc.c  */
#line 2023 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); ;}
    break;

  case 493:

/* Line 1464 of yacc.c  */
#line 2026 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); ;}
    break;

  case 494:

/* Line 1464 of yacc.c  */
#line 2031 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); ;}
    break;

  case 495:

/* Line 1464 of yacc.c  */
#line 2034 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); ;}
    break;

  case 496:

/* Line 1464 of yacc.c  */
#line 2037 "cf-parse.y"
    { ospf_sh_lsadb(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf)); ;}
    break;

  case 497:

/* Line 1464 of yacc.c  */
#line 2042 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  ;}
    break;

  case 500:

/* Line 1464 of yacc.c  */
#line 2052 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 501:

/* Line 1464 of yacc.c  */
#line 2057 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 502:

/* Line 1464 of yacc.c  */
#line 2058 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 503:

/* Line 1464 of yacc.c  */
#line 2065 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
;}
    break;

  case 505:

/* Line 1464 of yacc.c  */
#line 2073 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); ;}
    break;

  case 510:

/* Line 1464 of yacc.c  */
#line 2087 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 2101 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); ;}
    break;

  case 512:

/* Line 1464 of yacc.c  */
#line 2102 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); ;}
    break;

  case 513:

/* Line 1464 of yacc.c  */
#line 2103 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); ;}
    break;

  case 514:

/* Line 1464 of yacc.c  */
#line 2104 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); ;}
    break;

  case 515:

/* Line 1464 of yacc.c  */
#line 2105 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); ;}
    break;

  case 516:

/* Line 1464 of yacc.c  */
#line 2106 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); ;}
    break;

  case 517:

/* Line 1464 of yacc.c  */
#line 2107 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); ;}
    break;

  case 518:

/* Line 1464 of yacc.c  */
#line 2108 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); ;}
    break;

  case 519:

/* Line 1464 of yacc.c  */
#line 2109 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); ;}
    break;

  case 520:

/* Line 1464 of yacc.c  */
#line 2110 "cf-parse.y"
    { RADV_IFACE->default_lifetime = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000"); ;}
    break;

  case 521:

/* Line 1464 of yacc.c  */
#line 2111 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); ;}
    break;

  case 522:

/* Line 1464 of yacc.c  */
#line 2115 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = _MAX(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
;}
    break;

  case 528:

/* Line 1464 of yacc.c  */
#line 2148 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
;}
    break;

  case 529:

/* Line 1464 of yacc.c  */
#line 2160 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); ;}
    break;

  case 530:

/* Line 1464 of yacc.c  */
#line 2161 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); ;}
    break;

  case 531:

/* Line 1464 of yacc.c  */
#line 2162 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); ;}
    break;

  case 532:

/* Line 1464 of yacc.c  */
#line 2163 "cf-parse.y"
    { RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Valid lifetime must be 0 or positive"); ;}
    break;

  case 533:

/* Line 1464 of yacc.c  */
#line 2164 "cf-parse.y"
    { RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Preferred lifetime must be 0 or positive"); ;}
    break;

  case 534:

/* Line 1464 of yacc.c  */
#line 2168 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");
;}
    break;

  case 540:

/* Line 1464 of yacc.c  */
#line 2190 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 543:

/* Line 1464 of yacc.c  */
#line 2199 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 544:

/* Line 1464 of yacc.c  */
#line 2200 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 545:

/* Line 1464 of yacc.c  */
#line 2201 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 546:

/* Line 1464 of yacc.c  */
#line 2202 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 547:

/* Line 1464 of yacc.c  */
#line 2203 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 548:

/* Line 1464 of yacc.c  */
#line 2204 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 550:

/* Line 1464 of yacc.c  */
#line 2206 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 551:

/* Line 1464 of yacc.c  */
#line 2207 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 552:

/* Line 1464 of yacc.c  */
#line 2208 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 554:

/* Line 1464 of yacc.c  */
#line 2213 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 555:

/* Line 1464 of yacc.c  */
#line 2214 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 556:

/* Line 1464 of yacc.c  */
#line 2215 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 557:

/* Line 1464 of yacc.c  */
#line 2220 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 558:

/* Line 1464 of yacc.c  */
#line 2221 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 559:

/* Line 1464 of yacc.c  */
#line 2222 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 560:

/* Line 1464 of yacc.c  */
#line 2223 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 561:

/* Line 1464 of yacc.c  */
#line 2224 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 563:

/* Line 1464 of yacc.c  */
#line 2228 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 564:

/* Line 1464 of yacc.c  */
#line 2229 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 569:

/* Line 1464 of yacc.c  */
#line 2243 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 571:

/* Line 1464 of yacc.c  */
#line 2259 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 574:

/* Line 1464 of yacc.c  */
#line 2268 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); ;}
    break;

  case 576:

/* Line 1464 of yacc.c  */
#line 2272 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 577:

/* Line 1464 of yacc.c  */
#line 2281 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (2)].a);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   ;}
    break;

  case 578:

/* Line 1464 of yacc.c  */
#line 2288 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   ;}
    break;

  case 579:

/* Line 1464 of yacc.c  */
#line 2295 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; ;}
    break;

  case 580:

/* Line 1464 of yacc.c  */
#line 2296 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; ;}
    break;

  case 581:

/* Line 1464 of yacc.c  */
#line 2300 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 582:

/* Line 1464 of yacc.c  */
#line 2304 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   ;}
    break;

  case 583:

/* Line 1464 of yacc.c  */
#line 2310 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   ;}
    break;

  case 584:

/* Line 1464 of yacc.c  */
#line 2313 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 585:

/* Line 1464 of yacc.c  */
#line 2314 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 586:

/* Line 1464 of yacc.c  */
#line 2315 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 587:

/* Line 1464 of yacc.c  */
#line 2319 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 641:

/* Line 1464 of yacc.c  */
#line 2327 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 642:

/* Line 1464 of yacc.c  */
#line 2327 "cf-parse.y"
    { ospf_proto_finish(); ;}
    break;

  case 645:

/* Line 1464 of yacc.c  */
#line 2327 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 654:

/* Line 1464 of yacc.c  */
#line 2331 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); ;}
    break;

  case 655:

/* Line 1464 of yacc.c  */
#line 2331 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 656:

/* Line 1464 of yacc.c  */
#line 2332 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 657:

/* Line 1464 of yacc.c  */
#line 2333 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 658:

/* Line 1464 of yacc.c  */
#line 2334 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 659:

/* Line 1464 of yacc.c  */
#line 2335 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 660:

/* Line 1464 of yacc.c  */
#line 2336 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 661:

/* Line 1464 of yacc.c  */
#line 2337 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 662:

/* Line 1464 of yacc.c  */
#line 2338 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 663:

/* Line 1464 of yacc.c  */
#line 2339 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 664:

/* Line 1464 of yacc.c  */
#line 2340 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); ;}
    break;

  case 665:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); ;}
    break;

  case 666:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 667:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 668:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 669:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); ;}
    break;

  case 670:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 671:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1464 of yacc.c  */
#line 7546 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 2343 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


